/*
 *        Htt.c 1.4 91/09/01  
 * 
 * Derived from  Main.c	2.1 91/08/13 11:28:33 FUJITSU LIMITED. */
/*
****************************************************************************

              Copyright 1991, by FUJITSU LIMITED
              Copyright 1991, by Sun Microsystems, Inc.	      

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of FUJITSU LIMITED and Sun
Microsystems, Inc. not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

FUJITSU LIMITED AND SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

Auther: Takashi Fujiwara	FUJITSU LIMITED
				fujiwara@a80.tech.yk.fujitsu.co.jp
	Kiyoaki oya		FUJITSU LIMITED
	Riki	Kawaguchi	FUJITSU LIMITED
	Tomoki	Kuriki		FUJITSU LIMITED
	Hideki  Hiura           (hhiura@Sun.COM) Sun Microsystems, Inc.

****************************************************************************
*/

#ifndef lint
#ident  "@(#)Htt.c	1.118    93/03/30 SMI"
static char     derived_from_sccs_id[] = "Main.c	2.1 91/08/13 11:28:33 FUJITSU LIMITED.";
#endif

#include <stdio.h>
#ifdef X_LOCALE
#include <X11/Xlocale.h>
#else
#include <locale.h>
#endif
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xresource.h>
#include <X11/Xatom.h>
#include <unistd.h>

#include "htt_icon"

#include <signal.h>
#include <sys/wait.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <fcntl.h>

#ifdef	SVR4
#include <sys/systeminfo.h>
#include <netdb.h>
#include <libintl.h>
#include <sys/param.h>
#else
#include <sys/param.h>
#endif
#include "Htt.h"
#include "HttLkup.h"

#define MIN_SHMEM_LEN 4096
#define MAX_SHMEM_LEN (MIN_SHMEM_LEN*4)
long *sh_mem ;
htt_t *htt ;

Private XIMStyle        styles_implemented[MAXSTYLES] = {
    XIMPreeditCallbacks | XIMStatusArea,
    XIMPreeditPosition  | XIMStatusArea,
    XIMPreeditCallbacks | XIMStatusNothing,
    XIMPreeditPosition  | XIMStatusNothing,
    XIMPreeditCallbacks | XIMStatusNone,
    XIMPreeditPosition  | XIMStatusNone,
    XIMPreeditArea      | XIMStatusArea,
    XIMPreeditArea      | XIMStatusNothing,
    XIMPreeditArea      | XIMStatusNone,
    XIMPreeditNothing   | XIMStatusArea,
    XIMPreeditNothing   | XIMStatusNothing,
    XIMPreeditNothing   | XIMStatusNone,
    XIMPreeditNone      | XIMStatusArea,
    XIMPreeditNone      | XIMStatusNothing,
    XIMPreeditNone      | XIMStatusNone,
    /*
     * StatusCallbacks cause lots of problems.
     * Basically StatusCallbacks should be disabled by defaults
     */
    XIMPreeditCallbacks | XIMStatusCallbacks,
    XIMPreeditPosition  | XIMStatusCallbacks,
    XIMPreeditArea      | XIMStatusCallbacks,
    XIMPreeditNothing   | XIMStatusCallbacks,
    XIMPreeditNone      | XIMStatusCallbacks,
};

extern void	DisplayStatus_wcs() ;
extern void	CreateRootWindow();
extern void	ChangeRootWindow();
extern int	GetIntDefault();
extern int	GetEnumDefault();
extern char	*GetStringDefault();
unsigned long	GetPixelByName();

static Bool	xsf_Search_PreeditWindow();
static void	GetRootWindowWidth();
static int	GetPreeditOverDefault();
static char	*GetDefaultLocale();
static void     HttRespondToWM();
static void 	ReplaceKeyArgv();
static char	*extract_command_name();
static char	*get_class_name();
static void	SetDefaultBaseFontName();
static void	UpdateHttResource();
void            ExitProcess();
static XrmDatabase	GetAppDefaults();

#ifdef DEBUG
int             dbg_flag = 0;
int             xsync = 0;
#endif				/* DEBUG */

static unsigned char   vendor_name[] = "Sun Microsystems Inc.";
static unsigned char   server_name[] = "htt";
static unsigned char   server_version[] = "2.2.0";
static unsigned char   server_full_name[64];

static Atom     WMSaveYourSelfAtom;
static Atom	WMProtocolsAtom;
static Atom	XrmAtom;

static char	*default_locale_name = "C";
static char	*display_name = NULL;
static char	*resource_file = NULL;
static Bool	args_iconic = False;
static char	*default_font_name;
static unsigned char   *title;
static int	title_on = 1;

static Window		icon_window;
static Pixmap		icon_pixmap;
static GC		icon_gc;

#define	EXPECTED_RES_NAME_LEN	32
static int	cmdname_len;
static int	max_xrm_len = EXPECTED_RES_NAME_LEN;
/*
char	*xrm_inst_name;
char	*xrm_class_name;
*/
#ifdef	CMSG_ONLY
Bool             client_is_cmsg_only = True ;
#else	/* CMSG_ONLY */
Bool             client_is_cmsg_only = False ;
#endif	/* CMSG_ONLY */

#define gray_width 16
#define gray_height 16
static unsigned char gray_bits[] = {
    0xff, 0xff, 0x55, 0x55, 0xff, 0xff, 0x55, 0x55, 0xff, 0xff, 0x55, 0x55,
    0xff, 0xff, 0x55, 0x55, 0xff, 0xff, 0x55, 0x55, 0xff, 0xff, 0x55, 0x55,
    0xff, 0xff, 0x55, 0x55, 0xff, 0xff, 0x55, 0x55};

static HttResourceEnums over_t[] = {
	{"none", PREEDIT_OVER_NON}, {"scroll", PREEDIT_OVER_SCROLL},
	{"extent", PREEDIT_OVER_EXTENT}, {0,0}
};
static HttResourceEnums kb_t[] = {
	{"none", FKEY_NONE}, {"jis", FKEY_G_JIS}, {"oyaubi", FKEY_G_OYA}, {0,0}
};
static HttResourceEnums yn_t[] = {
	{"on", 1}, {"On", 1}, {"True", 1}, {"true", 1},
	{"off", 0}, {"Off", 0}, {"False", 0}, {"false", 0}, {0,0}
};
static HttResourceEnums fback_t[] = {
	{"none", FEEDBACK_NONE}, {"stipple", FEEDBACK_STIPPLE}, 
	{"unmap", FEEDBACK_UNMAP}, {0,0}
};
static HttResourceEnums sp_t[] = {
	{"left", STATUS_LEFT}, {"right", STATUS_RIGHT}, 
	{0,0}
};
  
static int	num_opt = 13;
static XrmOptionDescRec optable[] = {
{"-fn",		"*font",	XrmoptionSepArg,	(XPointer)NULL},
{"-fg",		"*foreground",	XrmoptionSepArg,	(XPointer)NULL},
{"-bg",		"*background",	XrmoptionSepArg,	(XPointer)NULL},
{"-bp",		"*backgroundPixmap",	XrmoptionSepArg,(XPointer)NULL},
{"-bw",		"*borderWidth",	XrmoptionSepArg,	(XPointer)NULL},
{"-bd",		"*borderColor",XrmoptionSepArg,		(XPointer)NULL},
{"-root_geom",	"*root.geometry",XrmoptionSepArg,	(XPointer)NULL},
{"-icongeom",	"*icon.geometry",XrmoptionSepArg,	(XPointer)NULL},
{"-lucfn",	"*lookup.font",	XrmoptionSepArg,	(XPointer)NULL},
{"-lucbg",	"*lookup.background",	XrmoptionSepArg,(XPointer)NULL},
{"-lucfg",	"*lookup.foreground",	XrmoptionSepArg,(XPointer)NULL},
{"-lucstyle",	"*lookup.style",XrmoptionSepArg,	(XPointer)NULL},
{"-lc_basiclocale","*basicLocale",XrmoptionSepArg,	(XPointer)NULL},
};


static HttResources htt_resources[] = {
{"font",		"Font",			HttOffset(HttRec, font_name),  
		HTT_STR_T,	0, (XPointer)NULL},
{"foreground", 		"Foreground",		HttOffset(HttRec, foreground_color),
		HTT_STR_T,	0, (XPointer)"black"},
{"background",		"Background",		HttOffset(HttRec, background_color),
		HTT_STR_T,	0, (XPointer)"white"},
{"backgroundPixmap",	"BackgroundPixmap",	HttOffset(HttRec, background_pixmap),
		HTT_STR_T,	0 , (XPointer)NULL},
{"borderWidth",		"BorderWidth",		HttOffset(HttRec, bd_width),
		HTT_INT_T,	0, (XPointer)4},
{"borderColor",		"BorderColor",		HttOffset(HttRec, border_color),
		HTT_STR_T,	0, (XPointer)"black"},
{"root.geometry",	"Root.Geometry",	HttOffset(HttRec, rootgeometry),   
		HTT_STR_T,	0, (XPointer)NULL},
{"icon.geometry",	"Icon.Geometry",	HttOffset(HttRec,icon_geometry),
		HTT_STR_T,	0, (XPointer)NULL},
{"root.displayLines",		"Root.DisplayLines",	HttOffset(HttRec, ims_line),
		HTT_INT_T,	0, (XPointer)1},
{"preedit.root.nlines",	"Preedit.Root.Nlines",	HttOffset(HttRec, ims_preedit_line),
		HTT_INT_T,	0, (XPointer)1},
{"preedit.over.nlines",	"Preedit.Over.Nlines",	HttOffset(HttRec, max_preedit_line),
		HTT_INT_T,	0, (XPointer)4},
{"preedit.overflow",		"Preedit.Overflow",	HttOffset(HttRec, preedit_over_mode),
		HTT_ENUM_T,	over_t, (XPointer)PREEDIT_OVER_NON},
{"preedit.feedback",	"Preedit.Feedback",	HttOffset(HttRec, preedit_feedback),
		HTT_ENUM_T,	fback_t, (XPointer)FEEDBACK_STIPPLE},
{"preedit.overflowGlyph",	"Preedit.OverflowGlyph",	HttOffset(HttRec, glyph_name),
		HTT_STR_T,	0, (XPointer)"-sun-open look glyph-*-*-*--*-*-*-*-*-*"},
{"preedit.root.lineSpacing",	"Preedit.Root.LineSpacing",	HttOffset(HttRec, line_spacing),
		HTT_INT_T,	0, (XPointer)18},
{"status.position",	"Status.Position",	HttOffset(HttRec, status_pos),
		HTT_ENUM_T,	sp_t, (XPointer)STATUS_LEFT},
{"status.feedback",	"Status.Feedback",	HttOffset(HttRec, status_feedback),
		HTT_ENUM_T,	fback_t, (XPointer)FEEDBACK_STIPPLE},
{"preedit.caretColor",		"Preedit.CaretColor",	HttOffset(HttRec, caret_color),
		HTT_STR_T,	0, (XPointer)NULL},
/*** The following resource is an obsolete one.  bugid# 1115388
 ***{"imsPreeditColumn",	"ImsPreeditColumn",	HttOffset(HttRec, ims_preedit_column),
 ***		HTT_INT_T,	0, (XPointer)10},  
 *** Leave it fow now */
{"root.lookupTakeOver",         "Root.LookupTakeOver",  HttOffset(HttRec, lookup_takeover),
                HTT_ENUM_T,     yn_t, (XPointer)1},
{"status.root.maxWidth",        "Status.Root.MaxWidth", HttOffset(HttRec, status_root_maxwidth),
                HTT_INT_T,      0, (XPointer)8},
{0,0,0,0,0}
} ;

int 
X_ErrorHandler(display, event)
    Display        *display;
    XErrorEvent    *event;
{
    return (0);
}

int 
X_IOErrorHandler(display)
    Display        *display;
{
    ExitProcess();
}


main(argc, argv)
    int             argc;
    char           *argv[];
{
    int             i ;

    init_shared_mem();
    HttInit(argc, argv);
    htt->command_name = extract_command_name(argv[0]);

    htt->core->norestart = False ;
    htt->core->noprops = False ;
    /*
     *  Parse the command line arguments.
     */
    for(i=1; i<argc; i++){
	if(!strcmp(argv[i], "-display"))
		display_name = argv[++i];
	else if(!strcmp(argv[i], "-xrm_name"))
		resource_file = argv[++i];
	else if (!strcmp(argv[i], "-xrm_program"))
		htt->command_name = argv[++i];
	else if (!strcmp(argv[i], "-title")) {
		title_on = 1;
	        if(*argv[i + 1] != '-')
			title = (unsigned char *) argv[++i];
	}
	else if (!strcmp(argv[i], "-notitle"))
		title_on = 0;
	else if (!strcmp(argv[i], "-norestart"))
            htt->core->norestart = True;
	else if (!strcmp(argv[i], "-noprops"))
            htt->core->noprops = True;
	else if (!strcmp(argv[i], "-help")) {
		Usage();
		exit(0);
	}
#ifdef	DEBUG
	else if (!strcmp(argv[i], "-dbg"))
            dbg_flag = 1;
        else if (!strcmp(argv[i], "-sync"))
            xsync = 1;
#endif
	else {
	/* We should pass the rest of the options to XrmParseCommand() */
        }
    }

    htt->class_name   = get_class_name(htt->command_name);
    
    if(htt->core->noprops)
	/* this is only for testing purpose */
	htt_main(argc, argv);
    else
	smog(argc, argv);
}

char *shmalloc(size)
int size ;
{
#define CUROFFSET (*sh_mem)    
#define WORD_B	4
    char *addr ;

    if(CUROFFSET + size < MAX_SHMEM_LEN){
	addr = (char *)sh_mem + CUROFFSET ;
	CUROFFSET += size ;
	CUROFFSET += (WORD_B - CUROFFSET%WORD_B);
	return addr ;
    }
#undef WORD_B

#ifdef SVR4
	fprintf(stderr, "Htt: %s\n", dgettext("SUNW_XIM_HTT_MSG",
					"Htt: shared memory over flown"));
#else
	fprintf(stderr, "Htt: %s\n", "Htt: shared memory over flown");
#endif
	
    exit(-1) ;
}

HttInit(argc, argv)
    int		argc;
    char	**argv;
{
    HttCore	*core; 
    int		i;

    htt	   = (htt_t *)shmalloc(sizeof(htt_t));
    htt->im = (im_t *)shmalloc(sizeof(im_t));
    htt->im->htt = (void *)htt;
    htt->im->next = htt->im->prev = 0;

    htt->core = (HttCore *)shmalloc(sizeof(HttCore));
    htt->core->htt_master_pid = getpid();
    for(i = 0 ; i < MAXSTYLES ; i++){
	htt->core->styles[i] = styles_implemented[i] ;
    }
    htt->core->nstyles = MAXSTYLES ;
    htt->core->vendor_name = vendor_name;
    htt->core->server_name = server_name;
    htt->core->server_version = server_version;
    htt->core->server_full_name = server_full_name;

}

static char *
extract_command_name(com)
    char	*com;
{
    char	*progname, *tmp;
    int		len, i;
    
    len = strlen(com);
    tmp = com + len - 1;
    progname = (char *)0;;
    for(i=0; i<len; i++) {
	if(*tmp == '/') {
		progname = tmp + 1;
		break;
	}
	tmp--;
    }
    if(progname)
    	return (progname);
    else
	return(com);
}

static char *
get_class_name(com)
    char	*com;
{
    char	*class;

    class = (char *)malloc(strlen(com) + 1 );
    strcpy(class, com);
    *class = toupper(*com);

    return (class);
}

htt_main(argc, argv)
    int		argc;
    char	**argv;
{
    int 	   rc ;
    char	   *res_string;
    HttCore	   *core = HTT_CORE(htt);
    Display	   *display;
    char	   **aargv;
    int		   aargc;
    int		   i;
    char	*locale_name, *tmp;
    Bool	b;
    char	*s_type_return[20];
    XrmValue	r_value;
    char	*str_name, *class_name;

    XSetErrorHandler(X_ErrorHandler);
    XSetIOErrorHandler(X_IOErrorHandler);

    init_htt_main();

    display = core->display = XOpenDisplay(display_name);
    if (!display) {
	if(display_name) {
	    ErrorMessage(1, display_name);
	} else {
	    ErrorMessage(1, "");
	}
	return (-1);
    }
    core->screen = DefaultScreen(display);
    core->root = RootWindow(display, core->screen);

    /*
     *   Save our own arg list to use afeterwards as a response to
     *   WM_SAVE_YOURSELF protocol.
     *   We need 2 extra spaces to store -geom arg 
     *   regardless of the actual argument list.
     */
    aargc = argc;
    aargv = (char **)malloc( sizeof(char *) * (argc + 2) );

    for(i=0; i<argc; i++) {
        *aargv = (char *)malloc(strlen(argv[i]) + 1);
	strcpy(*aargv, argv[i]);
        aargv++;
    }
    aargv -= argc;

    XrmInitialize();
    XrmParseCommand(&htt->cmdlines, optable, num_opt, htt->command_name, 
					&argc, argv);

    /*
     *   Setup resource database.
     *   [0] Setup a constant string which is always passed to XrmGetResource().
     *   [1] rdb from -xrm_name option is merged to the rdb attached to Display.
     *   [2] Finally, the rdb from XrmParseCommand() overrides it.
     */
  /* [0] */
/*
    cmdname_len = strlen(htt->command_name);
    xrm_inst_name = (char *)malloc(cmdname_len + EXPECTED_RES_NAME_LEN + 2);
    xrm_class_name = (char *)malloc(cmdname_len + EXPECTED_RES_NAME_LEN + 2);
    strcpy(xrm_inst_name, htt->command_name);
    strcat(xrm_inst_name, ".");
    strcpy(xrm_class_name, htt->class_name);
    strcat(xrm_class_name, ".");
*/
  /* [1] */
    res_string = XResourceManagerString(display);
    if(res_string)
	htt->rdb = XrmGetStringDatabase(res_string);
    if(resource_file) {
    	htt->special = XrmGetFileDatabase(resource_file);
	XrmMergeDatabases(htt->special, &htt->rdb);
    }
  /* [2] */
    XrmMergeDatabases(htt->cmdlines, &htt->rdb);

    /*
     *   Determine the locale name.
     */
    str_name = "htt.basicLocale";
    class_name = "Htt.BasicLocale";
    b = XrmGetResource(htt->rdb, str_name, class_name,
				s_type_return, &r_value);
    if ( b && !strcmp(r_value.addr, "C") ) {
	/*
	 * Htt.BasicLocale is C.
	 */
	exit(0);
    } else if ( !b ) {
	/*
	 * Htt.BasicLocale is not set.
	 */
	str_name = "OpenWindows.basicLocale";
	class_name = "OpenWindows.BasicLocale";
	b = XrmGetResource(htt->rdb, str_name, class_name,
						s_type_return, &r_value);
	if ( b && !strcmp(r_value.addr, "C") ) {
	    /*
	     * OpenWindows.BasicLocale is C.
	     */
	    exit(0);
	} else if ( !b ) {
	    /*
	     * OpenWindows.BasicLocale is not set.
	     */
	    locale_name = setlocale(LC_CTYPE, "");
	    if (locale_name && !strcmp(locale_name, "C")) {
		/*
		 * LANG is C.
		 */
		exit(0);
	    }
	}
    }

    if (b) locale_name = r_value.addr;

    tmp = (char *)shmalloc(strlen(locale_name) + 1);
    strcpy(tmp, locale_name);
    core->locale_name = tmp;

    htt->app_defaults = GetAppDefaults(core->locale_name);

    XrmCombineDatabase(htt->app_defaults, &htt->rdb, False);

    /*
     *   Get defaut data other than the locale name.
     */
    GetDefaults(htt_resources, (XPointer)core);
    SupplementDefaults();


#ifdef SVR4
    /*
     *  Set message domain
     */
    {  
       char        *getenv(),make_path[MAXPATHLEN];   /* <sys/param.h> */
       char        *domainpath, *message_locale;
 
        message_locale = GetStringDefault( "OpenWindows.displayLang",
                               "OpenWindows.DisplayLang", default_locale_name);
 
        setlocale(LC_MESSAGES,message_locale);

#ifdef  DEBUG
	(void)dbg_printf( " Set LC_MESSAGES %s locale \n",message_locale);
#endif  /* DEBUG */
 
        domainpath = GetStringDefault( "textDomain",
                                "TextDomain",(char *)NULL);
        if(!domainpath) 
                domainpath = getenv("HTTMESSAGE");
        if(!domainpath){
                domainpath = getenv("OPENWINHOME");
		sprintf(make_path, "%s/lib/locale", domainpath);
		domainpath = &make_path[0];
	}
        if(domainpath){ 
            char *setdomainpath = NULL;
                setdomainpath = bindtextdomain("SUNW_XIM_HTT_MSG",domainpath);
#ifdef  DEBUG
                if(setdomainpath)
		    (void)dbg_printf("bindtextdomain passed: %s \n",setdomainpath);
                else
                    (void)dbg_printf("bindtextdomain failed: %s !!\n",domainpath);
#endif  /* DEBUG */
        }
     }
#endif /* SVR4 */

    if(!title) {	/* If not set by command line option */
#ifdef SVR4
        sprintf((char *) core->server_full_name, dgettext("SUNW_XIM_HTT_MSG",
            "%s - Input Method Server %s [%s]"),
            core->server_name, core->server_version, core->locale_name);
#else /* SVR4 */
        sprintf((char *) core->server_full_name,"%s - Input Method Server %s [%s]",
            core->server_name, core->server_version, core->locale_name);
#endif /* SVR4 */
        title = server_full_name;
    }

    /*
     * Locale set from Resource-DB
     */
    
    
    {
	char *s = core->locale_name ;
	int l   = (strlen(s)+sizeof(long))&(~(sizeof(long)-1)) ;
	core->locale_name = shmalloc(l);
	strcpy(core->locale_name, s);
	setlocale( LC_CTYPE, core->locale_name ) ;
    } 
    rc = InitialClientTable();
    if (rc)
	return (4);

    rc = CreateRoot(aargc, aargv);
    if (rc)
	return (4);

    SelectLookupChoiceStyle();
    rc = LookupChoiceInit();
    if (rc)
	return (4);

    CreateXimpAtom();
    SetSignals();

    imlimgr_init();
    MainLoop(aargc, aargv);
}
/*
 * somg is a status watcher process.
 * smog stands for following 3 acronyms depending on how often htt dies.
 * initial:      Server ha Mada Ochitenai Great (Server is not died yet, Great)
 * 1st recovery: Server ga Mou Ochinaiyouni Ganbarimasu. (Try not to die again)
 * 2nd recovery: Server ga Mata Ochita. Gomennasai (Sorry, died again and agan)
 */
#ifndef SIGCHLD
#define SIGCHLD SIGCLD
#endif

static void
htt_slave_dead(dummy)
int dummy;
{
    int status ;

    /*
     * Forget about old system V ;-)
     */
    if(waitpid(htt->core->htt_prop_pid, &status, WNOHANG ) == htt->core->htt_prop_pid ){
       /*
	* Hibernate until 4/93 (?)
	*
	fprintf(stderr, "htt master: exiting...\n");
	*
	*/
	kill(htt->core->htt_pid, SIGTERM);
	kill(htt->core->htt_prop_pid, SIGTERM);
	exit(0);
    }
    if(waitpid(htt->core->htt_pid, &status, WNOHANG ) == htt->core->htt_pid ){
	waitpid(htt->core->htt_pid, &status, 0) ;
    }
    return;
}
static
init_shared_mem()
{
    char *tmp = tmpnam(0);
#ifndef sun
    /* I don't know what to do */
#else
    int fd = open("/dev/zero", O_RDWR);
    
    if(fd < 0 ){
	perror("htt: shmem init");
	exit(1);
    }
    if((sh_mem = (long *)mmap(0, MAX_SHMEM_LEN, PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0)) == (long *)-1){
	printf("sh_mem %x %d\n", sh_mem, MAX_SHMEM_LEN);
	perror("htt: shmem mmap:");
	exit(1);
    }
    *sh_mem = sizeof(sh_mem) ;
#endif    
}
static void
smogquit(dummy)
int dummy;
{    
    kill(htt->core->htt_pid, SIGTERM);
    kill(htt->core->htt_prop_pid, SIGTERM);
    exit(0);
}
static
smog(argc, argv)
    int		argc;
    char      **argv;
{
    static time_t t, prev_t = 0 ; 
    pid_t	tmp;

    htt->core->too_fast_restart_count = 0;

#ifdef NEEDPROPERTYPROC
    /*
     * create property process
     */
    if((tmp = fork()) == 0){
	htt_prop_main(argc, argv) ;
	exit(-1);
    } else if(tmp < 0) {
	perror("htt prop daemon");
	exit(-1);
    }
    htt->core->htt_prop_pid = tmp;
#else 
    htt->core->htt_prop_pid = 0;
#endif
    signal(SIGHUP, smogquit);
    signal(SIGINT, smogquit);
    signal(SIGQUIT, smogquit);
    signal(SIGPIPE, smogquit);
    signal(SIGTERM, smogquit);
    for(;;){
	if((tmp = fork()) == 0){
	    htt_main(argc, argv);
	    exit(-1);
	} else if(tmp < 0) {
	    perror("htt");
	    exit(-1);
	} else {
	    int status ;
	    
	    htt->core->htt_pid = tmp;
	    signal(SIGCHLD, htt_slave_dead );
	    WAITLOOP:
	    if(waitpid(htt->core->htt_pid, &status, 0)<0){
		switch(errno){
		case ECHILD:
		    break;
		default:
		case EFAULT:
		case EINTR:
		    goto WAITLOOP;
		    break;
		case EINVAL:
		    fprintf(stderr, "BUG\n");
		    exit(-1);
		    break ;
		}
	    }
	    if(htt->core->norestart){
		kill(htt->core->htt_pid, SIGTERM);
		kill(htt->core->htt_prop_pid, SIGTERM);
		exit(0);
	    }
	}
	if(((t = time(0)) - prev_t) < 20){
	    if(htt->core->too_fast_restart_count ++ > 3) {
		kill(htt->core->htt_pid, SIGTERM);
		kill(htt->core->htt_prop_pid, SIGTERM);
		fprintf(stderr, "%s\n", dgettext("SUNW_XIM_HTT_MSG","htt: stop restarting.\n"));
		exit(0);
	    }
	} else {
	    htt->core->too_fast_restart_count = 0 ;
	}
	prev_t = t ;
    }
}	    
Usage()
{

    HTT_MSG("usage:\n       htt [-options ...]\n\nwhere options include:\n");
    HTT_MSG("    -help                         print out this message\n");
    HTT_MSG("    -display displayname          X server to contact\n");
    HTT_MSG("    -root_geom geom                size and posision in pixels\n");
    HTT_MSG("    -fn fontname                  default font set name\n");
    HTT_MSG("    -bg color                     background color\n");
    HTT_MSG("    -fg color                     foreground color\n");
    HTT_MSG("    -bd color                     border color\n");
    HTT_MSG("    -bp bitmap_file               pixmap used as the background\n");
    HTT_MSG("    -lc_basiclocale locale        locale name\n");
    HTT_MSG("    -xrm_name file                additional resource file\n");
    HTT_MSG("    -lucstyle {popup|rootwindow}  style of lookupchoice\n");
    HTT_MSG("    -lucfn fontname               font set name used in lookupchoice\n");
    HTT_MSG("    -lucbg color                  background color of lookupchoice\n");
    HTT_MSG("    -lucfg color                  foreground color of lookupchoice\n");
#if	notdef
    /* Already obsolete now */
    HTT_MSG("    -norestart                    disable auto restarting\n");
    HTT_MSG("    -icongeom geom                posision of the icona\n");
    HTT_MSG("    -bw number                    internal border in pixels\n");
    HTT_MSG("    -title string                 title string\n");
    HTT_MSG("    -notitle                      turn off title string\n");
#endif
}

void
ExitProcess()
{
    FXimp_Client	*root_client = GET_HTT_VALUE(htt, root_client);
    Display		*display =  GET_HTT_VALUE(htt, display);

    ExitClientTable();
/*
    XDestroyWindow(display, root_client->window);
    XCloseDisplay(display);
*/
    exit(0);
}

void
SignalExitFunc()
{
    htt->core->too_fast_restart_count = 0;
    ExitProcess();
}

SetSignals()
{
#ifdef USE_SIGNAL
    signal(SIGHUP, SIG_IGN);
    signal(SIGINT, SIG_IGN);
    signal(SIGQUIT, SIG_IGN);
    signal(SIGPIPE, SIG_IGN);
    signal(SIGTERM, (void (*) ()) SignalExitFunc);
#endif				/* USE_SIGNAL */
}

GetDefaults(r, base)
    HttResources	*r;
    XPointer		base;
{
    XPointer		addr;
    int			i;
    char		*p, *mp;

    while(r->name) {
	addr = (XPointer)(base + r->offset);
	switch(r->type) {
	   case HTT_INT_T:
		i = GetIntDefault(r->name, r->class, (int)r->default_value);
		bcopy(&i, addr, sizeof(int));
		break;
	   case HTT_STR_T:
		p = GetStringDefault(r->name, r->class, (char *)r->default_value);
		if(p) {
		    mp = (char *)malloc(strlen(p) + 1);
		    strcpy(mp, p);
		    bcopy(&mp, addr, sizeof(char *));
		}
		else {
		    bcopy(&p, addr, sizeof(char *));
		}
		break;
	   case HTT_ENUM_T:
		i = GetEnumDefault(r->name, r->class, (int)r->default_value,
					r->enumtab);
		bcopy(&i, addr, sizeof(int));
		break;
	   default:
		break;
	}
	r++;
    }
}

SupplementDefaults()
{
    HttCore	*core = HTT_CORE(htt);

    if(!core->font_name)
	SetDefaultBaseFontName(core->locale_name);
}

char           *
GetStringDefaultOfDisplay(display, inst_name, class_name, Default)
    Display	*display ;
    char        *inst_name, *class_name;
    char        *Default;
{
    char	*str_type[20];
    XrmValue    val;
    char       *xrm_inst_name;
    char       *xrm_class_name;

    if (strncmp(inst_name, "OpenWindows", 11)) {
	int	new_len;
	char	*p;
	int	cmdname_len = strlen(htt->command_name);

	xrm_inst_name = (char *)malloc(cmdname_len + EXPECTED_RES_NAME_LEN + 2);
	xrm_class_name = (char *)malloc(cmdname_len + EXPECTED_RES_NAME_LEN + 2);

	strcpy(xrm_inst_name, htt->command_name);
	strcat(xrm_inst_name, ".");
	strcpy(xrm_class_name, htt->class_name);
	strcat(xrm_class_name, ".");

	new_len = strlen(inst_name); 
	if( new_len > max_xrm_len ) {
	    xrm_inst_name = (char *)realloc((void *)xrm_inst_name,
				 		cmdname_len + new_len + 2 );
	    xrm_class_name = (char *)realloc((void *)xrm_class_name,
				 		cmdname_len + new_len + 2 );
	    max_xrm_len = new_len;
	}
	p = xrm_inst_name + cmdname_len + 1;
	strcpy(p, inst_name);
	p = xrm_class_name + cmdname_len + 1;
	strcpy(p, class_name);
    } else {
	xrm_inst_name = inst_name;
	xrm_class_name = class_name;
   }

    if(XrmGetResource(htt->rdb, xrm_inst_name, xrm_class_name, str_type, &val))
	return (char *)val.addr;
    else
	return Default;
}

char           *
GetStringDefault(inst_name, class_name, Default)
    char           *inst_name, *class_name;
    char           *Default;
{
    Display	*display = GET_HTT_VALUE(htt, display);
    return GetStringDefaultOfDisplay(display, inst_name, class_name, Default) ;
}

int
GetIntDefault(inst_name, class_name, Default)
    char           *inst_name, *class_name;
    int             Default;
{
    char        *str_type[20];
    XrmValue    val;   
    Display	*display = GET_HTT_VALUE(htt, display);
    int		new_len;
    char	*p;
    int         cmdname_len = strlen(htt->command_name);
    char       *xrm_inst_name = (char *)malloc(cmdname_len + EXPECTED_RES_NAME_LEN + 2);
    char       *xrm_class_name = (char *)malloc(cmdname_len + EXPECTED_RES_NAME_LEN + 2);

    strcpy(xrm_inst_name, htt->command_name);
    strcat(xrm_inst_name, ".");
    strcpy(xrm_class_name, htt->class_name);
    strcat(xrm_class_name, ".");

    new_len = strlen(inst_name); 
    if( new_len > max_xrm_len ) {
	xrm_inst_name = (char *)realloc((void *)xrm_inst_name,
				 		cmdname_len + new_len + 2 );
	xrm_class_name = (char *)realloc((void *)xrm_class_name,
				 		cmdname_len + new_len + 2 );
	max_xrm_len = new_len;
    }
    p = xrm_inst_name + cmdname_len + 1;
    strcpy(p, inst_name);
    p = xrm_class_name + cmdname_len + 1;
    strcpy(p, class_name);

    if(XrmGetResource(htt->rdb, xrm_inst_name, xrm_class_name, str_type, &val))
	return atoi(val.addr);
    else
	return Default;
}

int
GetEnumDefault(inst_name, class_name, Default, tab)
    char           *inst_name, *class_name;
    int             Default;
    HttResourceEnums	*tab;
{
    char        *str_type[20];
    XrmValue    val;   
    int         flag = -1;
    Display	*display = GET_HTT_VALUE(htt, display);
    HttResourceEnums	*tabt = tab;
    int		new_len;
    char	*p;
    int         cmdname_len = strlen(htt->command_name);
    char       *xrm_inst_name = (char *)malloc(cmdname_len + EXPECTED_RES_NAME_LEN + 2);
    char       *xrm_class_name = (char *)malloc(cmdname_len + EXPECTED_RES_NAME_LEN + 2);

    strcpy(xrm_inst_name, htt->command_name);
    strcat(xrm_inst_name, ".");
    strcpy(xrm_class_name, htt->class_name);
    strcat(xrm_class_name, ".");

    new_len = strlen(inst_name); 
    if( new_len > max_xrm_len ) {
	xrm_inst_name = (char *)realloc((void *)xrm_inst_name,
				 		cmdname_len + new_len + 2 );
	xrm_class_name = (char *)realloc((void *)xrm_class_name,
				 		cmdname_len + new_len + 2 );
	max_xrm_len = new_len;
    }
    p = xrm_inst_name + cmdname_len + 1;
    strcpy(p, inst_name);
    p = xrm_class_name + cmdname_len + 1;
    strcpy(p, class_name);

    if(XrmGetResource(htt->rdb, xrm_inst_name, xrm_class_name, str_type, &val)){
	while(tabt->name) {
		if(!strcmp(tabt->name, val.addr))
			return tabt->val;
		tabt++;
	}
    }

    return Default;
}

CreateRoot(argc, argv)
    int		argc;
    char	**argv;
{
    int				 default_depth;
    unsigned long		 foreground_pixel,
				 background_pixel,
				 border_pixel;
    unsigned long		 dummy;
    Colormap			 default_colormap;
    XSizeHints			 hints;
    XWMHints			 wm_hints;
    XClassHint			*httclasshint;
    XSetWindowAttributes	 attributes;
    int				 gravity;
    int				 rc, len;
    int                          num;
    Pixmap			 pixmap;
    Ximp_AreaRec		 preedit_area, *pre_area = &preedit_area;
    Ximp_AreaRec		 status_area, *sts_area = &status_area;
    Ximp_AreaRec		*ims_area;
    Ximp_StatusPropRec		*current_status;
    Ximp_PreeditPropRec		*current_preedit;
    FXimpFont			*current_status_font;
    XFontStruct			*glyph_font;
    XTextProperty		client_machine;
    XTextProperty		server_name_prop;
    XTextProperty		icon_name_prop;
    char			*host_name_list;
    char			host_name[MAXHOSTNAMELEN];
    Atom			wm_protocols[4];
    int				icon_x, icon_y;
    unsigned int		geom_dum;
    unsigned long		icon_gc_val_mask;
    FXimp_Client		*current_client;
    FXimpFont			*current_preedit_font;
    XGCValues			icon_gc_val;

    Display			*display = GET_HTT_VALUE(htt, display);
    int				screen = GET_HTT_VALUE(htt, screen);
    Window			root = GET_HTT_VALUE(htt, root);
#ifdef  sun
    Atom                        ol_wm_attr;
    struct{
                unsigned long   flags;
                Atom            win_type;
                long            menu_type;
                long            pin_state;
                long            cancel;
    }                           ol_wm_type;

#endif /* sun */

    HttCore                     *core = HTT_CORE(htt);
    XrmValue                    val;
    char                        *str_type[20];
    char                        color_name[20];
    XColor                      rgb_db_def;
    char			*icon_name = (char *)malloc(sizeof(char) * 40); 

    default_colormap = DefaultColormap(display, screen);
    foreground_pixel = GetPixelByName(display, default_colormap, 
		GET_HTT_VALUE(htt,foreground_color), WhitePixel(display, screen));
    background_pixel = GetPixelByName(display, default_colormap, 
		GET_HTT_VALUE(htt, background_color), BlackPixel(display, screen));
    border_pixel     = GetPixelByName(display, default_colormap, 
		GET_HTT_VALUE(htt, border_color), BlackPixel(display, screen));

    if (GET_HTT_VALUE(htt, keybord_type) != FKEY_NONE) {
	    SET_HTT_VALUE(htt, keybord_type, FKEY_NONE);
    }
    current_client = NewClient(1);
    SET_HTT_VALUE(htt, root_client, current_client);
    SET_HTT_VALUE(htt, current_client, current_client);

    current_preedit_font = current_client->preedit_font;
    Fj_InitialMode();

    current_client->status_fontname = GET_HTT_VALUE(htt, font_name);
    current_client->preedit_fontname = GET_HTT_VALUE(htt, font_name);
    rc = FXLoadQueryBaseFont(display, current_preedit_font, 
					GET_HTT_VALUE(htt, font_name));
    if (rc)
	return (-1);

    glyph_font = XLoadQueryFont(display, GET_HTT_VALUE(htt, glyph_name));
    if(!glyph_font)
	return (-1);
    SET_HTT_VALUE(htt, glyph_font, glyph_font);

    current_client->status_font = current_client->preedit_font;
    current_status_font = current_client->preedit_font;
    current_status  = current_client->status;
    current_preedit = current_client->preedit;

    current_client->style = (XIMPreeditNothing | XIMStatusNothing);

    current_status->Foreground = foreground_pixel;
    current_status->Background = background_pixel;

    current_preedit->LineSpacing = GET_HTT_VALUE(htt, line_spacing);
    current_preedit->Foreground = foreground_pixel;
    current_preedit->Background = background_pixel;
    current_preedit->SpotLocation.x = 0;
    current_preedit->SpotLocation.y = current_preedit_font->max_font_ascent;

    Get_IMSArea( current_client, current_client->ims_area,
		 pre_area, sts_area, &gravity );

    current_status->Area.width  = sts_area->width;
    current_status->Area.height = sts_area->height;
    current_status->Area.x = sts_area->x;
    current_status->Area.y = sts_area->y;
    current_preedit->Area.width  = pre_area->width;
    current_preedit->Area.height = pre_area->height;
    current_preedit->Area.x = pre_area->x;
    current_preedit->Area.y = pre_area->y;
    ims_area = current_client->ims_area;

    current_client->window = XCreateSimpleWindow( display, root,
				ims_area->x, ims_area->y,
				ims_area->width, ims_area->height, 
				GET_HTT_VALUE(htt, bd_width),
				border_pixel, background_pixel );
    htt->core->root_client_wid = current_client->window;
    current_client->focus_window = current_client->window;
    XStoreName(display, current_client->window, (char *) title);

    EntryFocusWindow( current_client, current_client->focus_window );

    if (!title_on) {
	bzero(&attributes, sizeof(XSetWindowAttributes));
	attributes.override_redirect = True;
	attributes.win_gravity = gravity;
	XChangeWindowAttributes(display, current_client->window,
			    CWOverrideRedirect | CWWinGravity, &attributes);
    }
    default_depth = DefaultDepth(display, screen);
    if (GET_HTT_VALUE(htt, background_pixmap)) {
	if (!strcmp(GET_HTT_VALUE(htt, background_pixmap), ".")) {
	    pixmap = XCreatePixmapFromBitmapData(display,
		     current_client->window, (char *) gray_bits, gray_width,
			    gray_height, background_pixel, foreground_pixel,
						 default_depth);
	} else {
	    pixmap = HttLocatePixmapFile(XScreenOfDisplay(display, screen), 
			GET_HTT_VALUE(htt, background_pixmap),
			background_pixel, foreground_pixel, default_depth,
			NULL, 0, NULL, NULL, NULL, NULL);
	}
	if (pixmap)
	    XSetWindowBackgroundPixmap(display, current_client->window, pixmap);
    } else {
	pixmap = 0;
    }

    current_preedit->Bg_Pixmap = pixmap;
    current_status->Bg_Pixmap  = pixmap;

 /*
  * Prepare for the icon image of Htt
  * Bitmap data comes from #include "htt_icon"
  */

    icon_window = XCreateSimpleWindow(display, root, 0, 0, 
				htt_icon_width, htt_icon_height, 0, 0,
				background_pixel);
    icon_gc_val_mask = GCForeground | GCBackground;
    icon_gc_val.foreground = foreground_pixel;

    if(XrmGetResource(htt->rdb, "openWindows.workspaceColor",
        "OpenWindows.WorkspaceColor", str_type, &val)) {
	strcpy(color_name, val.addr);
	color_name[strlen(val.addr)] = '\0';
	XParseColor(display, default_colormap, color_name,
		&rgb_db_def);
	XAllocColor(display, default_colormap, &rgb_db_def);
	icon_gc_val.background = rgb_db_def.pixel;
    } else {
	XWindowAttributes       def_attr;

	memset(&def_attr, 0, sizeof(XWindowAttributes));
	XGetWindowAttributes(display, GET_HTT_VALUE(htt, root), &def_attr);
	icon_gc_val.background = def_attr.backing_pixel;
    }
    icon_gc = XCreateGC(display, icon_window, icon_gc_val_mask, &icon_gc_val);
    
    XSelectInput(display, icon_window, ExposureMask);
    icon_pixmap = XCreateBitmapFromData(display, icon_window,
			htt_icon_bits, htt_icon_width, htt_icon_height);

    bzero(&wm_hints, sizeof(XWMHints));
    if( args_iconic )
	wm_hints.initial_state = IconicState;
    else
    	wm_hints.initial_state = NormalState;
    wm_hints.flags = InputHint | StateHint | IconWindowHint |
	IconPixmapHint;
    wm_hints.icon_window = icon_window;
    wm_hints.input = True;
    if(GET_HTT_VALUE(htt, icon_geometry)) {
    	XParseGeometry(GET_HTT_VALUE(htt, icon_geometry), &icon_x, &icon_y, 
				&geom_dum, &geom_dum);
    	wm_hints.icon_x = icon_x;
    	wm_hints.icon_y = icon_y;
        wm_hints.icon_pixmap = icon_pixmap;
	wm_hints.flags |= IconPositionHint;
    }
    XSetWMHints(display, current_client->window, &wm_hints);
    bzero(&hints, sizeof(XSizeHints));
    hints.flags = USSize | PMinSize | PBaseSize | USPosition | PWinGravity;
    hints.x = ims_area->x;
    hints.y = ims_area->y;
    hints.width  = ims_area->width;
    hints.height = ims_area->height;
    hints.min_width  = ims_area->width;
    hints.min_height = ims_area->height;
    hints.base_width  = ims_area->width;
    hints.base_height = ims_area->height;
    hints.win_gravity = gravity;

    memset(icon_name, 0, sizeof(char) * 40);
#ifdef SVR4
    strcpy(icon_name, dgettext("SUNW_XIM_HTT_MSG",
	"Input Method Server"));
#else
    strcpy(icon_name, "Input Method Server");
#endif
    XmbTextListToTextProperty(display, &(core->server_full_name), 1,
			XCompoundTextStyle, &server_name_prop);
    XmbTextListToTextProperty(display, &icon_name, 1,
			XCompoundTextStyle, &icon_name_prop);
    XSetWMProperties(display, current_client->window, &server_name_prop,
        &icon_name_prop, argv, argc, &hints, &wm_hints, NULL);
    free(icon_name);
    CreateRootWindow( current_client, pre_area, sts_area );

/*
 *   Prepare for the WM_PROTOCOL
 */
#ifdef	SVR4
    sysinfo(SI_HOSTNAME, host_name, MAXHOSTNAMELEN);
#else
    gethostname(host_name, MAXHOSTNAMELEN);
#endif
    /* 
     * Register WM_SAVE_YOURSELF so that htt gets a clientmessage
     * when SaveWorkSpace is executed
     */
    host_name_list = &host_name[0];
    XStringListToTextProperty(&host_name_list, 1, &client_machine);
    XSetWMClientMachine(display, current_client->window, &client_machine);
    WMSaveYourSelfAtom = XInternAtom(display, "WM_SAVE_YOURSELF", False);
    WMProtocolsAtom = XInternAtom(display, "WM_PROTOCOLS",False);
    wm_protocols[0] = WMSaveYourSelfAtom;
    XSetWMProtocols(display, current_client->window, wm_protocols, 1);

    /*
     * Register WM_CLASS so to be ICCM complient.
     * Moreover, to tell owplaces that htt should be saved
     * on the upper position in .openwin-init than any other
     * clients.
     */
    httclasshint = XAllocClassHint();
    httclasshint->res_name = htt->command_name;
    httclasshint->res_class = htt->class_name;
    XSetClassHint(display, current_client->window, httclasshint);
    
    XrmAtom = XInternAtom(display, "RESOURCE_MANAGER", False);
#ifdef sun
    ol_wm_attr = XInternAtom(display, "_OL_WIN_ATTR",  True);
    ol_wm_type.flags = 0x1;
    ol_wm_type.win_type = XInternAtom(display, "_OL_WT_OTHER", True);
    XChangeProperty(display, current_client->window,
                   ol_wm_attr, ol_wm_attr, 32,
                   PropModeReplace, (unsigned char *) &ol_wm_type, 5);
#endif /* sun */

    return (0);
}


MainLoop(argc, argv)
    int		argc;
    char	**argv;
{
    XEvent          event;
    unsigned long   mask;
    unsigned long   dummy;
    FXimp_Client	*root_client = GET_HTT_VALUE(htt, root_client);
    Display		*display = GET_HTT_VALUE(htt, display);
    extern int      CheckRootWindow();
    LookupInfo      *info = (LookupInfo *)GET_HTT_VALUE(htt, lookup_info);

    mask = StructureNotifyMask | FocusChangeMask | PropertyChangeMask |
	   EnterWindowMask | LeaveWindowMask | ExposureMask ;

    XSelectInput(display, root_client->window, mask);
    XSelectInput(display, root_client->status_window, ExposureMask);
    XSelectInput(display, root_client->preedit_window, ExposureMask);
    XSelectInput(display, RootWindow(display, 0), PropertyChangeMask);

    if(info->style == LOOKUP_MENU_IMSWINDOW ||
       info->style == LOOKUP_MENU_IMSWINDOW2) {
	XMapWindow(display, root_client->window);
	SET_HTT_VALUE(htt, ims_window_mapped, True);
    }
    for (;;) {
	XNextEvent(display, &event);
	if(htt->biff){
	    shmem_update_notify();
	}
	if(if_FilterEvent(&event))
	    continue ;
	switch (event.type) {
	case EnterNotify:
	case LeaveNotify:
	    if ((event.xcrossing.focus)
		&& (event.xcrossing.detail != NotifyInferior)
		&& (event.xcrossing.window != root_client->window)
		&& (SetCurrentClient(event.xcrossing.window) == 0)) {
		if (event.type == EnterNotify) {
		    SetFocusClient();
		} else {
		    UnsetFocusClient();
		    xsfIMLunsetfocus(CURRENT_CLIENT(htt));
		}
	    }
	    break;
	case Expose:
	    {
		FXimp_Client   *ximp_client;
		FXimp_Client	*focus_in_client;
		int	mode;
		int 	status_feedback=GET_HTT_VALUE(htt,status_feedback);

		focus_in_client=GET_HTT_VALUE(htt,focus_in_client);

		if(event.xany.window == icon_window) {
			XCopyPlane(display, icon_pixmap, icon_window, icon_gc,
				0, 0, htt_icon_width, htt_icon_height, 0, 0, 1);
			break;
		}
		if ( (GET_HTT_VALUE(htt, focus_in_client))
		  && ( (GET_HTT_VALUE(htt, focus_in_client)->status_window 
							== event.xany.window)
		    || (xsf_Search_PreeditWindow(
			GET_HTT_VALUE(htt, focus_in_client), event.xany.window))
		    || (GET_HTT_VALUE(htt, focus_in_client)->lookup_window 
							== event.xany.window)) )
		    ximp_client = GET_HTT_VALUE(htt, focus_in_client);
		else
		    ximp_client =
			FindClientByPreeditOrStatusWindowForRedisplay(event.xany.window);

		if (ximp_client) {
		    SET_HTT_VALUE(htt, current_client, ximp_client);
                    if (status_feedback == FEEDBACK_STIPPLE) {
                        if (focus_in_client == ximp_client)
                            mode = highlight;
                        else
                            mode = stipple;
                    }
                    else
                        mode = highlight;
		    if (event.xany.window == CURRENT_CLIENT(htt)->status_window)
			DisplayStatus_wcs(CURRENT_CLIENT(htt), mode);
		}
		PreeditRedisplay(&event);
		Lkup_Redisplay(&event, CURRENT_CLIENT(htt));
	    }
	    break;
	case KeyRelease:
	    XimpSendKeyrelease(event);
	    if(CURRENT_CLIENT(htt)->select_kanji_mod)
	    	(void)LucNeedsThisKeyEvent(&event, htt);
	    break ;
	case KeyPress:
	    if ( SetCurrentClient( event.xkey.window ) == 0 ) {
		if(!skip_for_fe_type3(&event, CURRENT_CLIENT(htt)))
			xsfKeyPress( CURRENT_CLIENT(htt), &event ) ;
	    }
	    else {
		if(!LucNeedsThisKeyEvent(&event, htt)) {
			WarningMessage(191);
		}
	    }
	    break;
	case ClientMessage:
	    if (event.xclient.message_type == GET_HTT_VALUE(htt, IMA_IMPROTOCOL)){
		XimpClientMessage(&event);
	    } else if(event.xclient.message_type == WMProtocolsAtom) {
		HttRespondToWM(&event, &argc, argv);
	    }
	    break;
	case DestroyNotify:
	    DestroyClientByFocus(event.xkey.window);
            CheckRootWindow();
	    break;
	case ConfigureNotify:
	    if ( event.xconfigure.window == root_client->window )
		ChangeRootWindow( event.xconfigure.x, event.xconfigure.y,
			 event.xconfigure.width, event.xconfigure.height );
	    else if(event.xconfigure.window == CURRENT_CLIENT(htt)->lookup_window)
		Lkup_Reconfigure(CURRENT_CLIENT(htt), &event);
	    else {
		FXimp_Client    *cl;
		if(cl = FindClientByFocusWindow(event.xconfigure.window))
			ClientMayBeResized(&event, cl);
	    }
	    break;
	case MapNotify:
	    if(event.xmap.window == root_client->window)
		SET_HTT_VALUE(htt, ims_window_mapped, True);
	    break;
	case UnmapNotify:
	    if(event.xunmap.window == root_client->window)
		SET_HTT_VALUE(htt, ims_window_mapped, False);
	    break;
	case PropertyNotify:
	    if(event.xproperty.window == root_client->window)
		XimpAtomPool(&event);
	    else
	    	UpdateHttResource(&event, htt);
	    break;
	}
    }
}

int
ChangeShiftMode(sw)
    int             sw;		/* 0: reset Map, 1: set Map 2: change Map */
{
}

static Bool
xsf_Search_PreeditWindow( client, check_window )
    FXimp_Client	*client;
    Window		 check_window;
{
    Htt_PreeditWinRec	*winfo = client->preedit_window_info;

    for ( ; winfo; winfo = winfo->next_link ) {
	if ( winfo->win_part == check_window ) {
	    return ( True );
	}
    }
    return ( False );
}

static void UpdateHttResource(evp, htt)
    XPropertyEvent	*evp;
    htt_t		*htt;
{
    Display	*display = GET_HTT_VALUE(htt, display);
    Atom	atype;
    int		aform;
    unsigned long	nitems, bafter;
    unsigned char *prop;
    int		nc;
    char	**text_list;
    XTextProperty	tp;

    if( (evp->atom != XrmAtom) || 
	(evp->window != RootWindow(display, 0)) )
	return;

    XGetWindowProperty(display, RootWindow(display, 0), XrmAtom,
		0L, 1000000L, False, AnyPropertyType,
		&atype, &aform, &nitems, &bafter, &prop);
    tp.value = prop;
    tp.encoding = XA_STRING;
    tp.format = 8;
    tp.nitems = nitems;
    XmbTextPropertyToTextList(display, &tp, &text_list, &nc);
    if(nc <= 0)
	return;

    XrmMergeDatabases(XrmGetStringDatabase(*text_list), &htt->rdb);
}

static XrmDatabase GetAppDefaults(locale)
char *locale;
{
    char	*getenv();
    XrmDatabase xrdb;
    char	def_search_path[MAXPATHLEN];
    char        *basepath = getenv("OPENWINHOME");
#define	LC_PATH_MAX	16
    char	lc_path[LC_PATH_MAX];

    if(!basepath)
	basepath="/usr/openwin";

    if (!locale)
	lc_path[0] = 0;
    else
	sprintf(lc_path, "locale/%s", locale);

    sprintf(def_search_path, "%s/lib/%s/app-defaults/htt", 
	basepath, lc_path);

    if (access(def_search_path, R_OK)) {
	sprintf(def_search_path, "%s/lib/%s/app-defaults/Htt",
							basepath, lc_path);
	if (access(def_search_path, R_OK) && locale) {
	    sprintf(def_search_path, "%s/lib/%s/app-defaults/Htt", 
		    basepath, htt->core->locale_name);
		if (!access(def_search_path, R_OK)) {
		    return NULL;
		}
	}
    }
#undef LC_PATH_MAX
    xrdb = XrmGetFileDatabase(def_search_path);
    return (xrdb);
}

static char *GetDefaultLocale(htt)
    htt_t	*htt;
{
    XrmDatabase	xrdb = htt->app_defaults;
    char        *str_type[20];
    XrmValue    val;
    char	*def_locale = NULL;

    if(XrmGetResource(xrdb, "basicLocale", "BasicLocale", str_type, &val)) 
	def_locale = (char *)(val.addr);
    return (def_locale);
    	
}
    
static void
SetDefaultBaseFontName(locale_string)
    char	*locale_string;
{
    HttCore	*core = HTT_CORE(htt);

    if (strncmp(locale_string, "ja", 2) == 0) {
	core->font_name = 
#ifdef OPENWIN
"-sun-gothic-medium-r-normal--16-140-75-75-c-70-jisx0201.1976-0,\
-sun-gothic-medium-r-normal--16-140-75-75-c-140-jisx0208.1983-0" ;
#else
"-*-fixed-medium-r-normal--*-*-*-*-*-*-*-*";
#endif
    }
    else if (strncmp(locale_string, "ko", 2) == 0) {
  	core->font_name = 
"-b&h-lucidatypewriter-medium-r-normal-sans-0-0-0-0-m-0-iso8859-1,\
 -sun-gothic-medium-r-normal--16-140-75-75-c-140-ksc5601.1987-0" ;
    } 
    else if ((!strcmp(locale_string, "chinese"))|| (!strcmp(locale_string, "zh"))) {
        core->font_name = 
"-b&h-lucidatypewriter-medium-r-normal-sans-0-0-0-0-m-0-iso8859-1,\
-sun-song-medium-r-normal--16-140-75-75-c-140-gb2312.1980-0";
    }
    else if ((!strcmp(locale_string, "tchinese"))||(!strcmp(locale_string,"zh_TW"))){ 
        core->font_name =
"-b&h-lucidatypewriter-medium-r-normal-sans-0-0-0-0-m-0-iso8859-1,\
-sun-sung-medium-r-normal--16-140-75-75-c-140-cns11643-1,\
-sun-sung-medium-r-normal--16-140-75-75-c-140-cns11643-2,\
-sun-sung-medium-r-normal--16-140-75-75-c-140-cns11643-14,\
-sun-sung-medium-r-normal--16-140-75-75-c-140-cns11643-15,\
-sun-sung-medium-r-normal--16-140-75-75-c-140-cns11643-16";
    }
    else {
	core->font_name = "-b&h-lucidatypewriter-medium-r-normal-sans-0-0-0-0-m-0-iso8859-1";
	core->locale_name = "C";
    }

}

static void
HttRespondToWM(ev, argcp, argv)
    XEvent	*ev;
    int		*argcp;
    char	**argv;
{
    XClientMessageEvent		*cmev = (XClientMessageEvent *)ev;
    XWindowAttributes   w_attr;  
    XWMHints	*wm_hints;
    static char        geom[32];
    XVisualInfo	vi, *vip;
    Window	child;
    int		ni, nx, ny;

    if(cmev->data.l[0] != WMSaveYourSelfAtom)
	return;

    XGetWindowAttributes(cmev->display, cmev->window, &w_attr);
    vi.visualid = XVisualIDFromVisual(w_attr.visual);
    vip = XGetVisualInfo(cmev->display, VisualIDMask, &vi, &ni);
    (void)XTranslateCoordinates(cmev->display, cmev->window, w_attr.root,
				-w_attr.border_width, -w_attr.border_width,
				&nx, &ny, &child);
    sprintf(geom, "%dx%d+%d+%d", w_attr.width, w_attr.height, nx, ny);
    ReplaceKeyArgv(argcp, argv, "-root_geom", geom);
    XSetCommand(cmev->display, cmev->window, argv, *argcp);
    
}

static void
ReplaceKeyArgv(argcp, argv, key, str)
    int		*argcp;
    char	**argv;
    char	*key;
    char	*str;
{
    char        **tmp = argv;
    int		i = *argcp;

    while(i--) {
	if(!strcmp(*tmp, key)) {
		tmp++;
		*tmp = (char *)realloc( (void *)(*tmp), strlen(str) + 1 );
		strcpy(*tmp, str);
		return;
	}
	tmp++;
    }	
    
    *tmp = (char *)malloc(strlen(key) + 1);
    strcpy(*tmp, key);
    tmp++;
    *tmp = (char *)malloc(strlen(str) + 1);
    strcpy(*tmp, str);
    (*argcp) += 2;
}

skip_for_fe_type3(evp, client)
    XKeyEvent   *evp;
    FXimp_Client        *client;
{
    KeySym      keysym;
    char        buf[10];
    XComposeStatus      status;

    if( !(client->style2 & XIMP_FE_TYPE3) ||
        (client->imp_mode & FIMP_BEGIN) )
                return (0);

    XLookupString(evp, buf, 10, &keysym, &status);
    if(IsMode(keysym, evp->state))
        return (0);
    else
        return (1);
}


init_htt_main()
{

        htt->cmdlines           =(XrmDatabase)NULL;
 
        htt->core->focus_in_client              = (FXimp_Client *)NULL;
        htt->core->previous_focus_in_client     = (FXimp_Client *)NULL;
        htt->core->current_client               = (FXimp_Client *)NULL;
        htt->core->previous_client              = (FXimp_Client *)NULL;

        htt->core->preedit_caret                = (PreeditCaret *)NULL;
        htt->core->root_preedit_caret           = (PreeditCaret *)NULL;

}

#ifdef DEBUG
dbg_printf(form, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16)
    char           *form;
    unsigned long   a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12,
                    a13, a14, a15, a16;
{
    if (dbg_flag) {
	fprintf(stderr, form,
		a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16);
	fflush(stderr);
    }
}
#endif	/* DEBUG */

