/*
 *        HttDisplay.c 1.4 91/09/01  
 * 
 * Derived from  Display.c	2.1 91/08/13 11:28:23 FUJITSU LIMITED. 
 */
/*
****************************************************************************

              Copyright 1991, by FUJITSU LIMITED

              Copyright 1991, by Sun Microsystems, Inc.	      

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of FUJITSU LIMITED and Sun
Microsystems, Inc. not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

FUJITSU LIMITED AND SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

Auther: Takashi Fujiwara	FUJITSU LIMITED
				fujiwara@a80.tech.yk.fujitsu.co.jp
	Kiyoaki oya		FUJITSU LIMITED
	Riki	Kawaguchi	FUJITSU LIMITED
	Tomoki	Kuriki		FUJITSU LIMITED
	Hideki  Hiura           (hhiura@Sun.COM) Sun Microsystems, Inc.

****************************************************************************
*/


#ifndef lint
#ident  "@(#)HttDisplay.c	1.62    93/03/23 SMI"
static char     derived_from_sccs_id[] = "Display.c	2.1 91/08/13 11:28:23 FUJITSU LIMITED.";
#endif

#include "Htt.h"
#include "HttLkup.h"
extern	htt_t	*htt;
#include <stdio.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>

extern void			DisplayStatus_wcs() ;
extern void			DisplayOutputBuff();
extern void			ResizePreeditArea();
extern void			MakePreeditInfo();
extern void			CopyPreeditInfo();
extern Htt_PreeditWinRec *	LinkPreeditInfo();
extern void			DestroyPreeditInfo();
extern void			Get_IMSArea();
extern void			ClientMayBeResized();
extern void			HttCaretWindowReparent();

static void			xsf_TextExtentsArea();
static void			xsf_Preedit_Overflow();
static void			xsf_DrawPreedit();
static void			xsf_DestroyPreeditWindow();
static void			xsf_PreeditMap();
static void			xsf_RedrawPreedit();
static void			DisplayScrollGlyph();
static void			xsf_MakePreeditInfoPos();
static Window			xsf_make_preedit_window();
static void			xsf_resize_ims_window();
static void			xsf_change_ims_window();
static void			xsf_check_status_geometry();
static void			xsf_check_preedit_geometry();
static void			xsf_create_status_window();
static void			xsf_create_preedit_window();
static void			xsf_change_status_window();
static void			xsf_change_preedit_window();
static int	                xsf_change_status_geometry();
static void			xsf_check_geometry();
static PreeditCaret		*FindPreeditCaret();
static void                     ApplyCaretShapeMask();

void            unmap_status_window();
void            unmap_preedit_window();
void            unmap_previous_root_client();
void            draw_preedit_area();
void            draw_status_area();
void            MapStatusWindow();
void            stipple_or_unmap_status_window();
void            stipple_or_unmap_preedit_window();
void            SetFocus_helper();
void            UnsetFocus_helper();

#define	AVOID_TOOL_CARET	3

static char reverse_order_of_events = (char)0;

int
SetFocusClient()
{
 
        int     preedit_feedback = GET_HTT_VALUE(htt, preedit_feedback);
        int     status_feedback = GET_HTT_VALUE(htt, status_feedback);
        FXimp_Client    *newclient = CURRENT_CLIENT(htt);
        FXimp_Client    *oldclient = GET_HTT_VALUE(htt, previous_client);
        FXimp_Client    *focus_in_client = GET_HTT_VALUE(htt,focus_in_client);
	FXimp_Client	*saved_client;

        xsf_change_ims_window (False);
        if (focus_in_client &&
                (focus_in_client != CURRENT_CLIENT(htt))) {
	    reverse_order_of_events = (char)0;

            saved_client = CURRENT_CLIENT(htt);
            SET_HTT_VALUE(htt,current_client,focus_in_client);
            UnsetFocusClient();
            SET_HTT_VALUE(htt,current_client,saved_client);
            newclient = CURRENT_CLIENT(htt);

	    reverse_order_of_events = (char)1;
        }
        oldclient = GET_HTT_VALUE(htt, previous_client);

        SetFocus_helper(oldclient, newclient);
        SET_HTT_VALUE(htt, focus_in_client, newclient);
        SetCurrentClientInFocus (newclient);
 
        if (newclient->select_kanji_mod)
            Lkup_FocusIn (newclient);
 
        xsfIMLsetfocus(newclient);
        if ((newclient->style & XIMPreeditNothing) ||
            (newclient->style & XIMStatusNothing))
           SET_HTT_VALUE(htt, previous_focus_in_client, newclient);

	if( !(newclient->style & XIMPreeditCallbacks) &&
            !(newclient->style & XIMPreeditNone ) &&
            !(newclient->select_kanji_mod == 1) &&
	    (GET_HTT_VALUE(htt, preedit_feedback) != FEEDBACK_NONE) )
		DisplayCursor(newclient, False);
		
        return(0);
}

int
UnsetFocusClient()
{
        FXimp_Client    *current_client = CURRENT_CLIENT(htt);
        FXimp_Client *focus_in_client = GET_HTT_VALUE(htt,focus_in_client);
 
        if ((current_client == NULL) ||
            (focus_in_client == NULL))
            return (0);
        if ((current_client != focus_in_client) || reverse_order_of_events)
	{
	    reverse_order_of_events = (char)0;
            return (0);
	}

        SET_HTT_VALUE(htt, previous_client, focus_in_client);
        UnsetFocus_helper(focus_in_client);
        SET_HTT_VALUE(htt, focus_in_client, NULL);

        if (current_client->select_kanji_mod)
            Lkup_FocusOut (current_client);
        return(0);
}

void
UnsetFocus_helper(client)
FXimp_Client *client;
{
        int     preedit_feedback = GET_HTT_VALUE(htt, preedit_feedback);
        int     status_feedback = GET_HTT_VALUE(htt, status_feedback);
 
        if (client == NULL)
           return;
 
        if ((preedit_feedback != FEEDBACK_NONE) &&
            (!(client->style & XIMPreeditCallbacks)))
            stipple_or_unmap_preedit_window(client, preedit_feedback);
        if ((status_feedback != FEEDBACK_NONE) &&
            (!(status_feedback & XIMStatusCallbacks)))
            stipple_or_unmap_status_window(client, status_feedback);
 
}

void
SetFocus_helper(oldclient, newclient)
FXimp_Client *oldclient, *newclient;
{
        FXimp_Client    *previous_root_client;
        int preedit_feedback=GET_HTT_VALUE(htt, preedit_feedback);
        int status_feedback=GET_HTT_VALUE(htt,status_feedback);

        previous_root_client =
                GET_HTT_VALUE(htt, previous_focus_in_client);

        if ((newclient == NULL) || (oldclient == NULL))
            return;

        /* oldclient is PreeditPosition, PreeditArea or
           PreeditRoot AND newclient is PreeditArea or
           PreeditPosition */

        if (((newclient->style & XIMPreeditPosition) ||
             (newclient->style & XIMPreeditArea)) &&
            ((oldclient->style & XIMPreeditPosition) ||
             (oldclient->style & XIMPreeditArea) ||
             (oldclient->style & XIMPreeditNothing))) {

	    /* Two lines at below are for bugid 1115253. */
	    if (newclient->style & XIMPreeditPosition)
		MapPreeditWindow();
            draw_preedit_area(newclient, highlight);

            if (oldclient != newclient) {
                if (newclient->style & XIMStatusArea)
                    draw_status_area(newclient, highlight);
                else if (newclient->style & XIMStatusNothing) {
                    if (previous_root_client != newclient) {
                        unmap_previous_root_client();
                        MapStatusWindow(newclient);
                    }
                    draw_status_area(newclient, highlight);
                }
            }
            else if (newclient->style & XIMStatusArea)
		draw_status_area(newclient, highlight);
        }
 
        /* oldclient is PreeditPosition or PreeditArea AND
           newclient is PreeditNothing */
 
        else if (((oldclient->style & XIMPreeditPosition) ||
                  (oldclient->style & XIMPreeditArea)) &&
                 (newclient->style & XIMPreeditNothing)) {
 
                if (previous_root_client != newclient) {
                    unmap_previous_root_client();
                    MapPreeditWindow();
                }
                draw_preedit_area(newclient, highlight);
 
                if (newclient->style & XIMStatusArea)
                    draw_status_area(newclient, highlight);
                else if (newclient->style & XIMStatusNothing) {
                    if (previous_root_client != newclient)
                        MapStatusWindow(newclient);
                    draw_status_area(newclient, highlight);
                }
        }
 
        /* oldclient and newclient are both PreeditNothing */
 
        else if ((oldclient->style & XIMPreeditNothing) &&
                 (newclient->style & XIMPreeditNothing)) {
 
           unmap_preedit_window(oldclient);
           MapPreeditWindow();
 
           draw_preedit_area(newclient, highlight);
 
           if ((oldclient->style & XIMStatusNothing) &&
                (oldclient != newclient))
                unmap_status_window(oldclient);
 
           if ((newclient->style & XIMStatusArea) &&
               (newclient != oldclient))
                draw_status_area(newclient, highlight);
           else if (newclient->style & XIMStatusNothing) {
                if (previous_root_client != newclient) {
                    unmap_previous_root_client();
                    MapStatusWindow(newclient);
                }
                draw_status_area(newclient, highlight);
           }
        }
 
         /* oldclient is PreeditCallbacks, and newclient is
           PreeditPosition or PreeditArea or PreeditRoot */
 
        else if ((oldclient->style & XIMPreeditCallbacks) &&
                 ((newclient->style & XIMPreeditPosition) ||
                  (newclient->style & XIMPreeditArea) ||
                  (newclient->style & XIMPreeditNothing))) {
 
            if ((newclient->style & XIMPreeditArea) ||
                (newclient->style & XIMPreeditPosition)) {
                if (newclient->style & XIMStatusNothing) {
                    if (previous_root_client != newclient) {
                        unmap_previous_root_client();
                        MapStatusWindow(newclient);
                    }
		    /* Two lines at below are for bugid 1115253. */
	       	    if (newclient->style & XIMPreeditPosition)
			MapPreeditWindow();
                    draw_status_area(newclient, highlight);
                }
            }
            else if (newclient->style & XIMPreeditNothing) {
                if (previous_root_client != newclient) {
                    unmap_previous_root_client();
                    MapPreeditWindow();
                    if (newclient->style & XIMStatusNothing)
                        MapStatusWindow(newclient);
                    draw_status_area(newclient, highlight);
                }
            }
            draw_preedit_area(newclient, highlight);
 
            if (newclient->style & XIMStatusArea)
                draw_status_area(newclient, highlight);
 
        }
 
       /* oldclient is PreeditPosition or PreeditArea or
           PreeditNothing AND newclient is PreeditCallbacks */
 
        else if (((oldclient->style & XIMPreeditArea) ||
                  (oldclient->style & XIMPreeditPosition) ||
                  (oldclient->style & XIMPreeditNothing)) &&
                 (newclient->style & XIMPreeditCallbacks)) {
 
            if (((oldclient->style & XIMPreeditNothing) ||
                      (oldclient->style & XIMStatusNothing)) &&
                     (newclient->style & XIMStatusNothing))
                unmap_preedit_window(oldclient);
        
             if (((oldclient->style & XIMStatusNothing) ||
                      (oldclient->style & XIMPreeditNothing)) &&
                     (newclient->style & XIMStatusNothing)) {
                    unmap_previous_root_client();
                    MapStatusWindow (newclient);
            }
 
            if ((newclient->style & XIMStatusArea) ||
                (newclient->style & XIMStatusNothing)) {
                draw_status_area(newclient, highlight);
            }
	}

        /* oldclient and newclient is PreeditCallbacks */
 
        else if ((oldclient->style & XIMPreeditCallbacks) &&
                 (newclient->style & XIMPreeditCallbacks))
        {
            if (newclient->style & XIMStatusArea)
                draw_status_area(newclient, highlight);
 
            else if (newclient->style & XIMStatusNothing) {
                if (oldclient->style & XIMStatusNothing)
                    unmap_status_window(oldclient);
                if (previous_root_client != newclient) {
                    unmap_previous_root_client();
                    MapStatusWindow(newclient);
                }
                else if (newclient->status_visible == 0) {
                    MapStatusWindow(newclient);
                }
 
                draw_status_area(newclient, highlight);
            }
        }

	/* Either one of old/newclient is/are None. */

	else 
	{
            if (newclient->style & XIMStatusArea)
                draw_status_area(newclient, highlight);
            else if (newclient->style & XIMStatusNothing) {
                if (oldclient->style & XIMStatusNothing)
                    unmap_status_window(oldclient);
                if (previous_root_client != newclient) {
                    unmap_previous_root_client();
                    MapStatusWindow(newclient);
                }
                else if (newclient->status_visible == 0) {
                    MapStatusWindow(newclient);
                }
 
                draw_status_area(newclient, highlight);
            }
	}

}


void
stipple_or_unmap_status_window(client, feedback)
FXimp_Client    *client;
int             feedback;
{
        if (feedback == FEEDBACK_STIPPLE)
            draw_status_area (client, stipple);
        else if (feedback == FEEDBACK_UNMAP)
            unmap_status_window (client);
}
 
void
stipple_or_unmap_preedit_window(client, feedback)
FXimp_Client    *client;
int             feedback;
{
        if (feedback == FEEDBACK_STIPPLE)
            draw_preedit_area (client, stipple);
        else if (feedback == FEEDBACK_UNMAP)
            unmap_preedit_window (client);

	UnmapCaretWindow(GET_HTT_VALUE(htt, display), client);
}
 
void
unmap_status_window(client)
FXimp_Client    *client;
{
        Display *display = GET_HTT_VALUE(htt,display);
 
        if (client->status_visible == 0)
            return;
 
        XUnmapWindow(display, client->status_window);
        client->status_visible = 0;
        if (((client->status_visible == 0) &&
             (client->style & XIMStatusNothing)) ||
            ((client->preedit_visible == 0) &&
             (client->style & XIMPreeditNothing)))
            SET_HTT_VALUE(htt,previous_focus_in_client,NULL);
}

void
unmap_preedit_window(client)
FXimp_Client    *client;
{
        Display *display = GET_HTT_VALUE(htt,display);
        Htt_PreeditWinRec *winfo = client->preedit_window_info;
 
        if (client->preedit_visible == 0)
            return;
 
        client->preedit_visible = 0;
        for ( ; winfo; winfo = winfo->next_link ) {
            if ( winfo->status & PREEDITWIN_CREATE ) {
                XUnmapWindow( display, winfo->win_part );
                winfo->status &= ~PREEDITWIN_MAP;
            }
        }
        if (((client->status_visible == 0) &&
             (client->style & XIMStatusNothing)) ||
            ((client->preedit_visible == 0) &&
             (client->style & XIMPreeditNothing)))
             SET_HTT_VALUE(htt,previous_focus_in_client,NULL);
}

void
unmap_previous_root_client()
{
        FXimp_Client    *client;
 
        client = GET_HTT_VALUE(htt, previous_focus_in_client);
 
        if (client) {
           if (client->style & XIMStatusNothing)
                unmap_status_window(client);
           if (client->style & XIMPreeditNothing)
                unmap_preedit_window(client);
        }
        SET_HTT_VALUE(htt, previous_focus_in_client, NULL);
}
 
 
void
draw_preedit_area(client, mode)
FXimp_Client    *client;
int     mode;
{
	Htt_PreeditWinRec	*winfo = client->preedit_window_info;

	for( ;winfo; winfo = winfo->next_link)
		xsf_RedrawPreedit(client, mode, winfo, 0, 0);
}

void
draw_status_area(client, mode)
FXimp_Client    *client;
int     mode;
{
        DisplayStatus_wcs (client, mode);
}

int
MapPreeditWindow()
{
    Htt_PreeditWinRec  *winfo = CURRENT_CLIENT(htt)->preedit_window_info;

#ifdef	DEBUG
	dbg_printf( "*** MapPreeditWindow ***\n" );
	dbg_printf( " henkan_mode=%d\n", CURRENT_CLIENT(htt)->henkan_mode );
#endif
    if (CURRENT_CLIENT(htt)->henkan_mode == 0
			|| (CURRENT_CLIENT(htt)->preedit_visible != 0
	    		&& CURRENT_CLIENT(htt)->prot_type == FPRT_XIM))
	return (0);

    xsf_PreeditMap();
    return (0);
}

void
MapStatusWindow( current_client )
    FXimp_Client	*current_client;
{
    Display	*display = GET_HTT_VALUE(htt, display);

    if ( current_client->status_window ) {
	    XMapRaised(display, current_client->status_window);
	    current_client->status_visible = 1;
    }
    return;
}

int
UnmapPreeditWindow()
{
    Display	*display = GET_HTT_VALUE(htt, display);
    Htt_PreeditWinRec  *winfo = CURRENT_CLIENT(htt)->preedit_window_info;

    if (CURRENT_CLIENT(htt)->preedit_visible == 0)
	return (0);

#ifdef DEBUG
    dbg_printf("  <UnmapPreeditWindow> CURRENT_CLIENT(htt)=%x preedit_window=%x\n", CURRENT_CLIENT(htt), CURRENT_CLIENT(htt)->preedit_window);
#endif	/* DEBUG */

    CURRENT_CLIENT(htt)->preedit_visible = 0;
    for ( ; winfo; winfo = winfo->next_link ) {
	if ( winfo->status & PREEDITWIN_CREATE ) {
	    XUnmapWindow( display, winfo->win_part );
	    winfo->status &= ~PREEDITWIN_MAP;
	}
    }
    return (0);
}

int 
UnmapCaretWindow(display, client)
    Display		*display;
    FXimp_Client	*client;
{
    Htt_PreeditTextRec *tinfo = &(client->preedit_text);

    XUnmapWindow(display, tinfo->caret_win);
    tinfo->caret_mapped = False;
}

void
PreeditRedisplay(e)
    XExposeEvent	*e;
{
    int 	    mode;
    FXimp_Client    *focus_in_client=GET_HTT_VALUE(htt, focus_in_client);
    int 	    preedit_feedback=GET_HTT_VALUE(htt, preedit_feedback);
    Htt_PreeditWinRec	*winfo;

    if (preedit_feedback == FEEDBACK_STIPPLE) {
        if (CURRENT_CLIENT(htt) == focus_in_client)
            mode = highlight;
        else
            mode = stipple;
    }
    else
        mode = highlight;

    winfo = CURRENT_CLIENT(htt)->preedit_window_info;
    for ( ; winfo; winfo = winfo->next_link ) {
	if(winfo->win_part == e->window) {
	    xsf_RedrawPreedit(CURRENT_CLIENT(htt), mode, winfo, e->x, e->width);
    	    DisplayCursor(CURRENT_CLIENT(htt), True);
	    return;
	}
    }    
}

extern void
ClearPreeditWindow( ic )
    FXimp_Client	*ic ;
{
    Display	*display = GET_HTT_VALUE(htt, display);
    Htt_PreeditWinRec  *winfo = ic->preedit_window_info;

#ifdef	DEBUG
	dbg_printf( "*** ClearPreeditWindow ***\n" );
#endif

    for ( ; winfo; winfo = winfo->next_link ) {
	if ( ( winfo->status & PREEDITWIN_CREATE )
	  && ( winfo->status & PREEDITWIN_MAP ) ) {
	    XClearWindow( display, winfo->win_part ) ;
	}
    }
    return;
}

/*
 * Clear Preedit Buffer
 */
void
ClearTextBuff( ic )
    FXimp_Client	*ic ;
{
    if ( ic->preedit_text.preedit_char )
	free( ic->preedit_text.preedit_char );
    if ( ic->preedit_text.preedit_attr )
	free( ic->preedit_text.preedit_attr );
    ic->preedit_text.caret_pos = 0 ;
    ic->preedit_text.preedit_char_len = 0 ;
    ic->preedit_text.preedit_char = NULL ;
    ic->preedit_text.preedit_attr = NULL ;
    ClearPreeditWindow( ic );
    return ;
}

extern void
DisplayOutputBuff(client, mode, redisplaying)
    FXimp_Client	*client;
    int		mode;
    Bool	redisplaying;
{
#ifdef DEBUG
    dbg_printf(" <DisplayOutputBuff> client=%x\n", client);
#endif	/* DEBUG */

    if (client->style & XIMPreeditPosition) {
	ResizePreeditArea(client);
	xsf_DrawPreedit(client, mode);
	return;
    }
    if (client->style & XIMPreeditNothing) {
	if (GET_HTT_VALUE(htt, status_pos) == STATUS_LEFT) {
	    (void) xsf_change_status_geometry(client);
	}
    }
    xsf_TextExtentsArea(redisplaying);
    xsf_DrawPreedit(client, mode);
    return;
}

extern void
ResizePreeditArea(client)
FXimp_Client	*client;
{
    FXimpFont  *current_preedit_font = client->preedit_font;
    Ximp_PreeditPropRec *current_preedit;

#ifdef DEBUG
    dbg_printf(" <ResizePreeditArea> client=%x\n", client);
#endif	/* DEBUG */

    current_preedit = client->preedit;
    if (client->check_preedit_area_size) {
        Ximp_PreeditPropRec preedit;
	preedit.Area.width = 0;
	preedit.Area.height = 0;
	CheckPreeditWidowSize(&preedit);
	if ((preedit.Area.width != current_preedit->Area.width)
	    || (preedit.Area.height != current_preedit->Area.height)) {
	    current_preedit->Area.width = preedit.Area.width;
	    current_preedit->Area.height = preedit.Area.height;
	    client->input_flag = FINF_MODY;
	}
    }
    if (client->style & XIMPreeditPosition) {
	if ( client->input_flag != FINF_NONE )
	    xsf_MakePreeditInfoPos( client,
			current_preedit, current_preedit_font );
	client->input_flag = FINF_NONE;
	xsf_TextExtentsArea(False);
	xsf_make_preedit_window( client, "XIMPreedit",
			   current_preedit, current_preedit_font, 0 );
	xsf_PreeditMap();
    }
    return;
}

/*
 * This Function is Status Drawing Module.
 *  Status String is only WideCharacters.
 */
extern void
DisplayStatus_wcs(work_client, mode)
    FXimp_Client   *work_client;
    int	mode;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *focus_in_client= GET_HTT_VALUE(htt, focus_in_client);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    int				 xx, yy, ww, length;
    FXimpFont			*current_status_font;
    Ximp_StatusPropRec		*current_status;
    FXimp_Client		*current_client;
    wchar_t			*status_message ;
    int		   sts_len;
    int	           sts_pos	 = GET_HTT_VALUE(htt, status_pos);

    current_client = work_client;
#ifdef	DEBUG
    (void)dbg_printf( "-- Display Status Window = %8.8x\n" ) ;
#endif	/* DEBUG */

    if (work_client->style & XIMPreeditNothing) {
	if (sts_pos == STATUS_LEFT) {
	    sts_len = xsf_change_status_geometry(work_client);
	}
    }

    if ( !focus_in_client ) {
	XMapRaised(display, current_client->status_window);
	current_client->status_visible = 1;
    }

    current_status_font = current_client->status_font;
    if (current_client->style & XIMStatusArea) {
	current_status = current_client->status;
    } else {
	current_status = root_client->status;
    }
    XClearWindow(display, current_client->status_window);
    length = GetImlStatus_wcs( work_client, &status_message ) ;
    if ( !status_message )
	return ;
    ww = FXTextWidth(current_status_font, status_message, length);
    if (sts_pos == STATUS_LEFT) {
	xx = current_status->Area.x;
    }
    else {
	xx = current_status->Area.width - ww;
    }
    yy = (current_status->Area.height - current_status_font->max_font_height + 1 ) / 2;
    yy += current_status_font->max_font_ascent;
    if (work_client->style & XIMPreeditNothing) {
	if (sts_pos == STATUS_LEFT) {
	    length = sts_len;
	}
    }
    FXDrawImageString(display, current_client->status_window,
		      current_status_font, 0, xx, yy,
		      status_message, length, mode);

    return ;
}


int
DisplayStatus(work_client, mode)
    FXimp_Client   *work_client;
    int		mode;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *focus_in_client= GET_HTT_VALUE(htt, focus_in_client);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    int             xx, yy, ww, length;
    FXimpFont      *current_status_font;
    Ximp_StatusPropRec *current_status;
    FXimp_Client   *current_client;
    ushort          status_message[21];

    current_client = work_client;

	current_status_font = current_client->status_font;
	if (current_client->style & XIMStatusArea) {
	    current_status = current_client->status;
	} else {
	    current_status = root_client->status;
	}
	XClearWindow(display, current_client->status_window);
	length = GetStatusMessage(work_client, status_message);
	ww = FXTextWidth(current_status_font, status_message, length);
	xx = current_status->Area.width - ww - GET_HTT_VALUE(htt, bd_width);
	yy = (current_status->Area.height - current_status_font->max_font_height + 1) / 2;
	yy += current_status_font->max_font_ascent;
	FXDrawImageString(display, current_client->status_window,
			  current_status_font, 0, xx, yy,
			  status_message, length, mode);

    return (0);
}

int
DisplayCursor(client, redisplaying)
FXimp_Client	*client;
Bool		redisplaying;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *focus_in_client= GET_HTT_VALUE(htt, focus_in_client);
    FXimpFont    *current_preedit_font = client->preedit_font;

    int			 width, hight;
    int			 cx, cy;
    int			 pos;
    int			 caret_pos;
    int			 half_width;
    Htt_PreeditWinRec	*winfo;
    Htt_PreeditTextRec	*tinfo = &client->preedit_text;
    PreeditCaret       *caret = tinfo->caret;

#ifdef	DEBUG
    (void)dbg_printf( "+++ DisplayCursor +++ focus_in=%8.8x, current=%8.8x\n",
			focus_in_client, client );
    (void)dbg_printf( " caret = %d, winfo_top : %8.8x\n",
		tinfo->caret_pos, client->preedit_window_info );
    (void)dbg_printf( " current_width=%d, width=%d\n",
		client->preedit_window_info->current_width,
		client->preedit_window_info->area_part.width );
#endif	/* DEBUG */

    if( !(client->imp_mode & FIMP_BEGIN) )
	return (0);
	
    caret_pos = tinfo->caret_pos;
    if ( tinfo->preedit_char_len != 0 ) {
	caret_pos++;
    } else {
	tinfo->cursor_in = client->preedit_window_info;
    }
    winfo = tinfo->cursor_in;
    pos = caret_pos - winfo->start_pos;
    pos = pos > 0 ? pos : 0;
    cx = FXTextWidth( current_preedit_font,
			tinfo->preedit_char + winfo->start_pos, pos );
    cy = 0;

    cx += (winfo->area_part.x+1);
    if((cy + caret->height) > (int)(winfo->area_part.height)) {
	cy += winfo->area_part.y;
    } else {
	cy += (winfo->area_part.y + AVOID_TOOL_CARET);
    }

#ifdef	DEBUG
    (void)dbg_printf( " winfo=%8.8x,x=%d,y=%d\n", winfo, cx, cy );
#endif

    XMoveWindow(display, tinfo->caret_win, cx, cy);
    if(!tinfo->caret_mapped && !redisplaying) {
    	XMapRaised(display, tinfo->caret_win);
        tinfo->caret_mapped = True;
    }
    else {
    	if(!redisplaying)
		XRaiseWindow(display, tinfo->caret_win);
    }
    XCopyArea(display, caret->pixmap, tinfo->caret_win, caret->gc,
			0, 0, caret->width, caret->height,
			0, 0);
    tinfo->caret_x = cx;
    tinfo->caret_y = cy;

    return (0);
}

int
CreatePreeditWindow()
{
    Display     *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);

    int		 rc;
    Window	 status_window;
    Ximp_PreeditPropRec	*current_preedit = CURRENT_CLIENT(htt)->preedit;
    FXimpFont	*current_preedit_font = CURRENT_CLIENT(htt)->preedit_font;
    Window	parent;

    if ( CURRENT_CLIENT(htt)->style & ( XIMPreeditCallbacks | XIMPreeditNone ) )
	return (0);

    if ( current_preedit->Foreground == current_preedit->Background ) {
	current_preedit->Foreground = root_client->preedit->Foreground;
	current_preedit->Background = root_client->preedit->Background;
    }

    if ( !( CURRENT_CLIENT(htt)->window_type & FC_SAME_ROOT_PREEDIT_FONT ) ) {
	rc = FXLoadQueryBaseFont(display, current_preedit_font,
				 CURRENT_CLIENT(htt)->preedit_fontname);
	if (rc) {
	    CURRENT_CLIENT(htt)->window_type |= FC_SAME_ROOT_PREEDIT_FONT;
	    *current_preedit_font = *root_client->preedit_font;
	    current_preedit_font->status = 0;
	}
    } else {
	*current_preedit_font = *root_client->preedit_font;
	current_preedit_font->status = 0;
    }
    parent = CURRENT_CLIENT(htt)->focus_window;
    CURRENT_CLIENT(htt)->preedit_text.caret = 
			FindPreeditCaret(CURRENT_CLIENT(htt), parent);
    return (0);
}

static PreeditCaret *
FindPreeditCaret(client, parent)
    FXimp_Client	*client;
    Window		parent;
{
    Display		*display = GET_HTT_VALUE(htt, display);
    PreeditCaret	*tmp = GET_HTT_VALUE(htt, preedit_caret);
    FXimpFont           *current_preedit_font = client->preedit_font;
    Ximp_PreeditPropRec *current_preedit = CURRENT_CLIENT(htt)->preedit;
    int			caret_width, caret_height;
    Window		caret_win;
    XPoint		points[16];
#define	NUM_SHAPE_POINTS	13

    if(client->style & XIMPreeditNothing) {
	tmp = GET_HTT_VALUE(htt, root_preedit_caret);
	if(tmp) {
		client->preedit_text.caret_win = 
			GET_HTT_VALUE(htt, root_caret_win);
		return tmp;
	}
	else 
		parent = GET_HTT_VALUE(htt, root_client)->window;	
    }

    caret_width = 3;
    caret_height = current_preedit_font->max_font_height - AVOID_TOOL_CARET;
    if((client->style & XIMPreeditArea) &&
       (current_preedit->Area.height < (current_preedit_font->max_font_height - AVOID_TOOL_CARET))) {
	caret_height = current_preedit->Area.height;
    }
    caret_win = XCreateSimpleWindow(display, parent, 0, 0,
			caret_width, caret_height, 0,
			client->preedit->Background,
			client->preedit->Background);
    client->preedit_text.caret_win = caret_win;

    points[0].x  = 0;  	points[0].y  = 0;
    points[1].x  = 3;  	points[1].y  = 0;
    points[2].x  = 3;  	points[2].y  = 1;
    points[3].x  = 2;  	points[3].y  = 1;
    points[4].x  = 2;   points[4].y  = caret_height - 1;
    points[5].x  = 3;   points[5].y  = caret_height - 1;
    points[6].x  = 3;   points[6].y  = caret_height;
    points[7].x  = 0;   points[7].y  = caret_height;
    points[8].x  = 0;   points[8].y  = caret_height - 1;
    points[9].x  = 1;   points[9].y  = caret_height - 1;
    points[10].x = 1;  	points[10].y = 1;
    points[11].x = 0;   points[11].y = 1;
    points[12].x = 0;   points[12].y = 0;

    if(!(client->style & XIMPreeditNothing)) {
        while(tmp) {
    	    if( 
			(tmp->screen == client->screen) && 
			(tmp->point == current_preedit_font->max_font_height) &&
			(tmp->bg == client->preedit->Background)
	     ) {
			ApplyCaretShapeMask(display, caret_win, 
				caret_width, caret_height, points, 
				NUM_SHAPE_POINTS, tmp);
			return (PreeditCaret *)tmp;
	    }
	    tmp = tmp->next;
        }
    }

    /*  Create a new caret pixmap */
    {
	Colormap	cmap;
        PreeditCaret	*new, *current_head;
	XGCValues	gcvals;
	unsigned long   gcvalmask = GCFunction | GCForeground | GCFillStyle;

    	new = (PreeditCaret *)malloc(sizeof(PreeditCaret));
	new->point = current_preedit_font->max_font_height;
	new->screen = client->screen;
	new->bg = client->preedit->Background;
	if(client->style & XIMPreeditNothing) {
        	SET_HTT_VALUE(htt, root_preedit_caret, new);
        	SET_HTT_VALUE(htt, root_caret_win, caret_win);
	}
	else {
		current_head = GET_HTT_VALUE(htt, preedit_caret);
		SET_HTT_VALUE(htt, preedit_caret, new);
		new->next = current_head;
	}
	new->shape_mask = XCreatePixmap(display,
			RootWindow(display, client->screen),
			caret_width, caret_height,
			1);
	new->width = caret_width;
	new->height = caret_height;
	new->pixmap =XCreatePixmap(display, RootWindow(display, client->screen),
				caret_width, caret_height,
				DefaultDepth(display, client->screen));
	gcvals.function = GXcopy;
	gcvals.fill_style = FillSolid;
	gcvals.foreground = new->bg;
	new->gc = XCreateGC(display, new->pixmap, gcvalmask, &gcvals);
	XFillRectangle(display, new->pixmap, new->gc, 0, 0,
					new->width, new->height);

	cmap = (client->preedit->Colormap) ?
			client->preedit->Colormap :
			DefaultColormap(display, new->screen);
	gcvals.foreground = GetPixelByName(display, cmap,
		GET_HTT_VALUE(htt, caret_color), client->preedit->Foreground);
	XChangeGC(display, new->gc, GCForeground, &gcvals);
	XFillPolygon(display, new->pixmap, new->gc, points, NUM_SHAPE_POINTS, 
				Convex, CoordModeOrigin);
	ApplyCaretShapeMask(display, caret_win,
				caret_width, caret_height, points, 
				NUM_SHAPE_POINTS, new);
	return (new);
    }
}

static void
ApplyCaretShapeMask(display, win, caret_width, caret_height, p, np, caret)
    Display		*display;
    Window		win;
    int			caret_width, caret_height;
    XPoint		*p;
    int			np;
    PreeditCaret	*caret;
{
    static GC		mask_gc = 0;
    XGCValues       	gcvals;
    typedef enum {
	ShapeENotQueried,
	ShapeESupported,
	ShapeENotSupported,
    } ShapeESupport;
    static ShapeESupport	shape_supprt = ShapeENotQueried;
    int			event_base, error_base;
    
    if(shape_supprt == ShapeENotQueried) {
	if(XShapeQueryExtension(display, &event_base, &error_base))
		shape_supprt = ShapeESupported;
	else
		shape_supprt = ShapeENotSupported;
    }

    if(shape_supprt == ShapeENotSupported)
	return;

    if(!mask_gc) {
	gcvals.foreground = 0;
	 mask_gc = XCreateGC(display, caret->shape_mask, GCForeground, &gcvals);
    }

    XSetForeground(display, mask_gc, 0);
    XFillRectangle(display, caret->shape_mask, mask_gc,
				0, 0, caret_width, caret_height);
    XSetForeground(display, mask_gc, 1);
    XFillPolygon(display, caret->shape_mask, mask_gc, p, np, 
			Convex, CoordModeOrigin);

    XShapeCombineMask(display, win, ShapeBounding, 0, 0, caret->shape_mask,
			ShapeSet);
    XShapeCombineMask(display, win, ShapeClip, 0, 0, caret->shape_mask,
			ShapeSet);

    XCopyArea(display, caret->pixmap, win, caret->gc, 
			0, 0, caret_width, caret_height, 0, 0);
}

void
HttCaretWindowReparent(display, client, focus_win)
    Display		*display;
    FXimp_Client	*client;
    Window		focus_win;
{
    Window	caret_win = client->preedit_text.caret_win;

    if(!caret_win || (client->style & XIMPreeditNothing))
	return;
    XReparentWindow(display, caret_win, focus_win, 0, 0);
}

int
ChangePreeditWindow(preedit)
    Ximp_PreeditPropRec *preedit;
{
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);

    Ximp_PreeditPropRec *current_preedit;
    int             rc;
    Window          status_window;

    if ( CURRENT_CLIENT(htt)->style & ( XIMPreeditCallbacks | XIMPreeditNone ) )
	return (0);

    current_preedit = CURRENT_CLIENT(htt)->preedit;
    if (current_preedit->Foreground == current_preedit->Background) {
	current_preedit->Foreground = root_client->preedit->Foreground;
	current_preedit->Background = root_client->preedit->Background;
    }

    return(0);
}

int
ChangePreeditFont()
{
    Display        *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    FXimpFont      *current_preedit_font = CURRENT_CLIENT(htt)->preedit_font;

    char		*work_ascii_kana_font_name,
			*work_kanji_font_name,
			*work_gaiji_font_name ;
    Ximp_PreeditPropRec *reference_preedit, *current_preedit;
    int			 rc ;
    Window		 status_window ;

    if ((CURRENT_CLIENT(htt)->style & XIMPreeditCallbacks)
	|| (CURRENT_CLIENT(htt)->style & XIMPreeditNone)) {
	return (0);
    }
    CURRENT_CLIENT(htt)->window_type &= ~FC_SAME_ROOT_PREEDIT_FONT;
    FXFreeFont(display, current_preedit_font);
    rc = FXLoadQueryBaseFont(display, current_preedit_font,
			     CURRENT_CLIENT(htt)->preedit_fontname);
    if (rc) {
	*current_preedit_font = *root_client->preedit_font;  /*!!!FIX ME ??? */
	current_preedit_font->status = 0;
	CURRENT_CLIENT(htt)->window_type |= FC_SAME_ROOT_PREEDIT_FONT;
    }
    current_preedit = CURRENT_CLIENT(htt)->preedit;
    FXChangeGC(display, CURRENT_CLIENT(htt)->preedit_window, current_preedit_font,
	       current_preedit->Foreground, current_preedit->Background);
    XClearArea(display, CURRENT_CLIENT(htt)->preedit_window, 0, 0, 0, 0, True);
    return (0);
}

int
CreateStatusWindow()
{
    Display     *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);

    Ximp_StatusPropRec	*current_status;
    FXimpFont		*current_status_font;
    Ximp_AreaRec	 imsfix_area,
			*ims_area = &imsfix_area;
    Ximp_AreaRec	 preedit_area,
			*pre_area = &preedit_area;
    Ximp_AreaRec	 status_area,
			*sts_area = &status_area;
    int			 rc;

    if ((CURRENT_CLIENT(htt)->style & XIMStatusCallbacks)
	|| (CURRENT_CLIENT(htt)->style & XIMStatusNone)) {
	return (0);
    }

    current_status_font = CURRENT_CLIENT(htt)->status_font;
    current_status = CURRENT_CLIENT(htt)->status;
    if (current_status->Foreground == current_status->Background) {
	current_status->Foreground = root_client->status->Foreground;
	current_status->Background = root_client->status->Background;
    }

    *current_status_font = *root_client->status_font;
    if ( !( CURRENT_CLIENT(htt)->window_type & FC_SAME_ROOT_STATUS_FONT ) ) {
	rc = FXLoadQueryBaseFont(display, current_status_font,
				 CURRENT_CLIENT(htt)->status_fontname);
	if (rc != 0) {
	    CURRENT_CLIENT(htt)->window_type |= FC_SAME_ROOT_STATUS_FONT;
	    *current_status_font = *root_client->status_font;
	    current_status_font->status = 0;
	}
    } else {
	*current_status_font = *root_client->status_font;
	current_status_font->status = 0;
    }
    return (0);
}

int
ChangeStatusWindow(status)
    Ximp_StatusPropRec *status;
{
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);

    Ximp_StatusPropRec *current_status;
    FXimpFont      *current_status_font;
    Window          parent;
    int             rc;

    if ( CURRENT_CLIENT(htt)->style & ( XIMStatusCallbacks | XIMStatusNone ) )
	return (0);

    current_status_font = CURRENT_CLIENT(htt)->status_font;
    current_status = CURRENT_CLIENT(htt)->status;
    if (current_status->Foreground == current_status->Background) {
	current_status->Foreground = root_client->status->Foreground;
	current_status->Background = root_client->status->Background;
    }
    return(0);
}

int
ChangeStatusFont()
{
    Display     *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);

    FXimpFont      *current_status_font;
    Ximp_StatusPropRec *current_status;
    int             rc;

    if ((CURRENT_CLIENT(htt)->style & XIMStatusCallbacks)
	|| (CURRENT_CLIENT(htt)->style & XIMStatusNone)) {
	return (0);
    }
    current_status_font = CURRENT_CLIENT(htt)->status_font;
    current_status = CURRENT_CLIENT(htt)->status;
    CURRENT_CLIENT(htt)->window_type &= ~FC_SAME_ROOT_STATUS_FONT;
    FXFreeFont(display, current_status_font);
    rc = FXLoadQueryBaseFont(display, current_status_font,
			     CURRENT_CLIENT(htt)->status_fontname);
    if (rc != 0) {
	*current_status_font = *root_client->status_font;
	current_status_font->status = 0;
	CURRENT_CLIENT(htt)->window_type |= FC_SAME_ROOT_STATUS_FONT;
    }
    FXChangeGC(display, CURRENT_CLIENT(htt)->status_window, current_status_font,
	       current_status->Foreground, current_status->Background);
    XClearArea(display, CURRENT_CLIENT(htt)->status_window, 0, 0, 0, 0, True);
    return (0);
}

int
ChangePreeditWindowAttributes(display, window, preedit)
    Display        *display;
    Window          window;
    Ximp_PreeditPropRec *preedit;
{
    unsigned long   valuemask;
    XSetWindowAttributes attributes;

    valuemask = 0;
    bzero(&attributes, sizeof(attributes));
    if (preedit->Bg_Pixmap) {
	attributes.background_pixmap = preedit->Bg_Pixmap;
	valuemask |= CWBackPixmap;
    }
    if (preedit->Cursor) {
	attributes.cursor = preedit->Cursor;
	valuemask |= CWCursor;
    }
    if (preedit->Colormap) {
	attributes.colormap = preedit->Colormap;
	valuemask |= CWColormap;
    }
    attributes.bit_gravity = NorthWestGravity;
    valuemask |= CWBitGravity;
    if (valuemask) {
	XChangeWindowAttributes(display, window, valuemask, &attributes);
    }
    return (0);
}

int
ChangeStatusWindowAttributes(display, window, status)
    Display        *display;
    Window          window;
    Ximp_StatusPropRec	*status;
{
    unsigned long   valuemask;
    XSetWindowAttributes attributes;

    valuemask = 0;
    bzero(&attributes, sizeof(attributes));
    if (status->Bg_Pixmap) {
	attributes.background_pixmap = status->Bg_Pixmap;
	valuemask |= CWBackPixmap;
    }
    if (status->Cursor) {
	attributes.cursor = status->Cursor;
	valuemask |= CWCursor;
    }
    if (status->Colormap) {
	attributes.colormap = status->Colormap;
	valuemask |= CWColormap;
    }
    if (valuemask) {
	XChangeWindowAttributes(display, window, valuemask, &attributes);
    }
    return (0);
}

int
CreatePreeditPositionWindow(current_client, current_preedit_font)
    FXimp_Client   *current_client;
    FXimpFont      *current_preedit_font;
{
    Ximp_PreeditPropRec *current_preedit = current_client->preedit;

    xsf_MakePreeditInfoPos( current_client,
			current_preedit, current_preedit_font );
    current_client->preedit_window =
    		xsf_make_preedit_window( current_client, "XIMPreeditPosition",
				   current_preedit, current_preedit_font, 0 );
    CheckPreeditWidowSize( current_preedit );
    return;
}

int
CheckPreeditWidowSize(preedit)
    Ximp_PreeditPropRec *preedit;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    Window          root_return;
    int             x_return, y_return;
    unsigned int    width_return, height_return, border_width_return, depth_return;

    if (preedit->Area.width == 0
	&& preedit->Area.height == 0) {
	CURRENT_CLIENT(htt)->check_preedit_area_size = 1;
	if (XGetGeometry(display, (Drawable) CURRENT_CLIENT(htt)->focus_window,
	  &root_return, &x_return, &y_return, &width_return, &height_return,
			 &border_width_return, &depth_return)) {
	    preedit->Area.width = width_return;
	    preedit->Area.height = height_return;
	    return (0);
	}
	return (-1);
    }
    return (0);
}

int
DestroyPreeditWindow(flag)
    int             flag;
{
    Display      *display = GET_HTT_VALUE(htt, display);
    FXimpFont    *current_preedit_font = CURRENT_CLIENT(htt)->preedit_font;

    if ((CURRENT_CLIENT(htt)->window_type & FC_SAME_ROOT_PREEDIT)
	== FC_SAME_ROOT_PREEDIT) {
	return (0);
    }
    if (CURRENT_CLIENT(htt)->style & XIMPreeditNothing) {
	if (!(CURRENT_CLIENT(htt)->window_type & FC_SAME_ROOT_PREEDIT_WINDOW))
	    XDestroyWindow(display, CURRENT_CLIENT(htt)->preedit_window);
    }
    if (flag == 0)
	if (CURRENT_CLIENT(htt)->style & XIMPreeditPosition) {
	    xsf_DestroyPreeditWindow();
	}
    if (!(CURRENT_CLIENT(htt)->window_type & FC_SAME_ROOT_PREEDIT_GC))
	FXFreeGC(display, current_preedit_font);
    if (!(CURRENT_CLIENT(htt)->window_type & FC_SAME_ROOT_PREEDIT_FONT))
	FXFreeFont(display, current_preedit_font);
    return (0);
}

int
DestroyStatusWindow(flag)
    int             flag;
{
    Display     *display = GET_HTT_VALUE(htt, display);

    if ((CURRENT_CLIENT(htt)->window_type & FC_SAME_ROOT_STATUS)
	== FC_SAME_ROOT_STATUS) {
	return (0);
    }
    if (!(CURRENT_CLIENT(htt)->window_type & FC_SAME_ROOT_STATUS_FONT))
	FXFreeFont(display, CURRENT_CLIENT(htt)->status_font);

    if (CURRENT_CLIENT(htt)->style & (XIMStatusNothing | XIMStatusArea)) {
	if (flag == 0)
	    if (!(CURRENT_CLIENT(htt)->window_type & FC_SAME_ROOT_STATUS_WINDOW))
		XDestroyWindow(display, CURRENT_CLIENT(htt)->status_window);
    }
    if (!(CURRENT_CLIENT(htt)->window_type & FC_SAME_ROOT_STATUS_GC))
	FXFreeGC(display, CURRENT_CLIENT(htt)->status_font);
    return (0);
}

static Window
xsf_make_preedit_window( current_client,
			 name, preedit_attr, preedit_font, mode )
    FXimp_Client	*current_client;
    char		*name;
    Ximp_PreeditPropRec	*preedit_attr;
    FXimpFont		*preedit_font;
    int			 mode;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);

    Window		 parent;
    int			 n;
    int			 x, y, width, height;
    Htt_PreeditWinRec	*winfo;
    char		 win_name[32];

#ifdef DEBUG
	dbg_printf( "*** xsf_make_preedit_window ***\n" );
#endif
    if ( mode == PREEDITWIN_ROOT ) {
	parent = root_client->window;
    } else if ( current_client->style & XIMPreeditArea ) {
	parent = current_client->window;
    } else {
	parent = current_client->focus_window;
    }

    x = current_client->preedit_window_info->area_part.x;
    y = current_client->preedit_window_info->area_part.y;
    current_client->preedit_window_info->current_width =
		MAX(1, current_client->preedit_window_info->current_width);
    width = current_client->preedit_window_info->current_width;
    height = current_client->preedit_window_info->area_part.height;

    for ( winfo = current_client->preedit_window_info, n = 0;
				winfo; winfo = winfo->next_link, n++ ) {
	if ( winfo->status & PREEDITWIN_LINKED )
	    continue;
	if ( winfo->status & PREEDITWIN_CREATE ) { 
	    if ( winfo->status & PREEDITWIN_MODIFY )
		XMoveResizeWindow( display, winfo->win_part,
			winfo->area_part.x, winfo->area_part.y,
			winfo->current_width, winfo->area_part.height );
	} else {
	    int		pos_x = x, pos_y =y;
	    if ( mode == PREEDITWIN_ROOT ) {
		pos_x = winfo->area_part.x;
		pos_y = winfo->area_part.y;
	    }
	    winfo->win_part = XCreateSimpleWindow( display, parent,
			    pos_x, pos_y, width, height,
			    0, preedit_attr->Foreground,
			    preedit_attr->Background ) ;
	    XUnmapWindow( display, winfo->win_part );
	    (void)sprintf( win_name, "%s%d", name, n );
	    XmbSetWMProperties(display, winfo->win_part, &win_name[0],
			NULL, 0, NULL, NULL, NULL, NULL);
	    ChangePreeditWindowAttributes( display, winfo->win_part,
					current_client->preedit );
	    winfo->status |= PREEDITWIN_CREATE;
    	    XSelectInput( display, winfo->win_part, ExposureMask );
	}
	winfo->status &= ~PREEDITWIN_MODIFY;
    }
    return ( current_client->preedit_window_info->win_part );
}

static void
xsf_TextExtentsArea(redisplaying)
    Bool	redisplaying;
{
    FXimpFont    *current_preedit_font = CURRENT_CLIENT(htt)->preedit_font;

    Htt_PreeditTextRec	*tinfo;
    Htt_PreeditWinRec	*winfo;
    wchar_t		*preedit_char;
    int			 total_width,
			 total_char_count,
			 char_count,
			 width;
#ifdef DEBUG
	dbg_printf( "*** xsf_TextExtentsArea ***\n" );
#endif
    tinfo = &CURRENT_CLIENT(htt)->preedit_text;
    winfo = CURRENT_CLIENT(htt)->preedit_window_info;
    tinfo->preedit_over = False;
    for ( total_width = 0; winfo != NULL; winfo = winfo->next_link ) {
	total_width += winfo->area_part.width;
	winfo->start_pos = winfo->draw_char_len = 0;
    }
    width = FXTextWidth( current_preedit_font,
			tinfo->preedit_char, tinfo->preedit_char_len );
    /*
     * Cursor space keep
     */
    if ( total_width < width ) {
	xsf_Preedit_Overflow();
	xsf_PreeditMap();
	return;
    }

    winfo = CURRENT_CLIENT(htt)->preedit_window_info;
    preedit_char = tinfo->preedit_char;
    total_char_count = 0;
    for ( ; winfo != NULL; winfo = winfo->next_link ) {
#ifdef DEBUG
	dbg_printf( "    winfo=%8.8x\n", winfo );
#endif
	if ( total_char_count > tinfo->preedit_char_len )
	    break;
	total_width = 0;
	winfo->start_pos = total_char_count;
	for ( char_count = 0; total_char_count <= tinfo->preedit_char_len;
			total_char_count++ ) {
	    if ( total_char_count < tinfo->preedit_char_len ) {
		width = FXTextWidth( current_preedit_font, preedit_char, 1 );
		if ((unsigned long)( total_width + width ) >= 
				(unsigned long)winfo->area_part.width )
		    break;
		preedit_char++; char_count++;
	    } else {
		width = 0;
		if ((unsigned long)( total_width + width ) >= 
				(unsigned long)winfo->area_part.width )
		    break;
	    }
	    total_width += width;
	}
	winfo->draw_char_len = char_count;
	if ( winfo->current_width != total_width ) {
	    winfo->current_width = total_width;
	    winfo->status |= PREEDITWIN_MODIFY;
	}
	tinfo->cursor_in = winfo;
    }

    for ( ; winfo; winfo = winfo->next_link ) {
	    winfo->current_width = 0;
    }

    if ( total_char_count <= tinfo->preedit_char_len )
	xsf_Preedit_Overflow();
    if(!redisplaying)
    	xsf_PreeditMap();
    return;
}

static void
xsf_Preedit_Overflow()
{
    FXimpFont    *current_preedit_font = CURRENT_CLIENT(htt)->preedit_font;

    Htt_PreeditTextRec	*tinfo;
    Htt_PreeditWinRec	*winfo;
    wchar_t		*preedit_char;
    int			 total_width,
			 total_char_count,
			 char_count,
			 width;

    tinfo = &CURRENT_CLIENT(htt)->preedit_text;
    winfo = (Htt_PreeditWinRec *)CURRENT_CLIENT(htt)->preedit_window_info;
    if ( winfo == NULL )
	return;

    tinfo->preedit_over = True;
    for ( ; winfo->next_link != NULL; winfo = winfo->next_link );

    preedit_char = tinfo->preedit_char + tinfo->preedit_char_len - 1;
    total_char_count = tinfo->preedit_char_len;
    for ( ; winfo != NULL; winfo = winfo->back_link ) {
	if ( total_char_count == 0 )
	    break;
	total_width = 0;
	for ( char_count = 0; total_char_count > 0;
			preedit_char--, char_count++, total_char_count-- ) {
	    width = FXTextWidth( current_preedit_font, preedit_char, 1 );
	    if ((unsigned long)(total_width + width) > (unsigned long)winfo->area_part.width ) {
		winfo->start_pos = total_char_count;
		winfo->draw_char_len = char_count;
		winfo->current_width = total_width;
		break;
	    }
	    total_width += width;
	}
    }
    return;
}

static void
xsf_PreeditMap()
{
    Display     *display = GET_HTT_VALUE(htt, display);
    Htt_PreeditWinRec	*winfo;
    int			 map_count=0;

#ifdef	DEBUG
	dbg_printf( "*** xsf_PreeditMap ***\n" );
#endif

	winfo = CURRENT_CLIENT(htt)->preedit_window_info;
	for ( ; winfo != NULL; winfo = winfo->next_link ) {
	    if  ( !( winfo->status & PREEDITWIN_CREATE ) )
		continue;
	    if ( ( winfo->current_width > 1 )
	      && ( CURRENT_CLIENT(htt)->henkan_mode == 1 ) ) {
			winfo->status |= PREEDITWIN_MAP;
			map_count++;
			XMapRaised( display, winfo->win_part );
	    } else {
		if ( winfo->status & PREEDITWIN_MAP ) {
		    winfo->status &= ~PREEDITWIN_MAP;
		    XUnmapWindow( display, winfo->win_part );
		}
	    }
	}
	if ( map_count != 0 ) {
	    CURRENT_CLIENT(htt)->preedit_visible = 1;
	} else {
	    CURRENT_CLIENT(htt)->preedit_visible = 0;
	}

    return;
}

static void
xsf_DrawPreedit(client, mode)
FXimp_Client	*client;
int		mode;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    FXimpFont    *current_preedit_font = client->preedit_font;
    int			 lx;
    int			 draw_x;
    int			 draw_y;
    int			 width;
    Htt_PreeditWinRec	*winfo;
    Htt_PreeditTextRec	*tinfo = &client->preedit_text;
    wchar_t	    	*text;
    XIMFeedback		*attr;
    int			drawn_chars = 0;
    int			this_head, this_len;

#ifdef	DEBUG
	dbg_printf( "*** xsf_DrawPreedit ***\n" );
#endif
    winfo = client->preedit_window_info;
    if ( tinfo->preedit_char_len == 0 ) {
#ifdef	DEBUG
	dbg_printf( "    Clear Preedit Window\n" );
#endif
	XClearWindow( display, winfo->win_part );
	tinfo->chg_first = 0;
	return;
    }

    for ( ; winfo != NULL; winfo = winfo->next_link ) {
	int	last_pos = winfo->start_pos + winfo->draw_char_len;
	if ( !(winfo->status & PREEDITWIN_CREATE)
              || !(winfo->status & PREEDITWIN_MAP) )
			continue;

	text = tinfo->preedit_char + winfo->start_pos;
	attr = tinfo->preedit_attr + winfo->start_pos;

	if(tinfo->preedit_over) {
	    draw_x = 0;
	    draw_y = current_preedit_font->max_font_ascent;
	    this_len = winfo->draw_char_len;
	    XClearArea(display, winfo->win_part, draw_x, 0, 0, 0, False);
	    HttDrawXIMString(display, winfo->win_part, current_preedit_font,
                                attr, draw_x, draw_y, text, this_len, mode);
	}
	else if(tinfo->chg_first < last_pos) {
	    this_head = tinfo->chg_first - drawn_chars;
	    if(this_head < 0)
		this_head = 0;
	    this_len = winfo->draw_char_len - this_head;
	    draw_x = FXTextWidth(current_preedit_font, text, this_head);
	    draw_y = current_preedit_font->max_font_ascent;
	    attr += this_head;
	    text += this_head;
	    XClearArea(display, winfo->win_part, draw_x, 0, 0, 0, False);
	    HttDrawXIMString(display, winfo->win_part, current_preedit_font,
				attr, draw_x, draw_y, text, this_len, mode);
	}
	drawn_chars += (winfo->draw_char_len);
    }
    if ( ( tinfo->preedit_over )
           && ( GET_HTT_VALUE(htt, preedit_over_mode) != PREEDIT_OVER_NON ) ) 
	DisplayScrollGlyph(client->preedit_window_info);

}

static void
DisplayScrollGlyph(winfo)
    Htt_PreeditWinRec	*winfo;
{
    static unsigned char	glyph_arrow[] = {0xe4, 0x00};
    Display	*display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    XGCValues	gc_val;
    GC		gc = root_client->preedit_font->normal_gc;
    Font	save_font;
    XCharStruct	*ci;

    ci = GET_HTT_VALUE(htt, glyph_font)->per_char + glyph_arrow[0];
    XGetGCValues(display, gc, GCFont, &gc_val);
    save_font = gc_val.font;
    gc_val.font = GET_HTT_VALUE(htt, glyph_font)->fid;
    XChangeGC(display, gc, GCFont, &gc_val);
    XDrawImageString(display, winfo->win_part, gc,
		0, ci->ascent , glyph_arrow, 1);
    gc_val.font = save_font;
    XChangeGC(display, gc, GCFont, &gc_val);

}

static void
xsf_RedrawPreedit(cl, mode, winfo, x, width)
    FXimp_Client	*cl;
    int			mode;
    Htt_PreeditWinRec	*winfo;
    int			x;
    int			width;
{
    Display	*display = GET_HTT_VALUE(htt, display);
    Htt_PreeditTextRec	*tinfo = &cl->preedit_text;
    wchar_t	*text;
    wchar_t	*top;
    XIMFeedback	*attr;
    FXimpFont	*p_font = cl->preedit_font;
    int		i;
    int		c_width;
    int		textlen;
    int		leftwidth = 0;
    int		topinx = 0;
    int         tailinx = winfo->draw_char_len - 1;
    int		draw_x;
    Bool	need_redraw = False;

    text = tinfo->preedit_char + winfo->start_pos;
    attr = tinfo->preedit_attr + winfo->start_pos;
  
    for(i=0; i<=tailinx; i++) {
	c_width = FXTextWidth(p_font, text, 1);
	leftwidth += c_width;
	if(leftwidth > x) {
		topinx = i;
		leftwidth -= c_width;
		need_redraw = True;
	    	break;
	}
	text++;
    }

    if(!need_redraw) {
	XClearArea(display, winfo->win_part, leftwidth, 0, 0, 0, False);
	return;
    }

    top = text = tinfo->preedit_char + winfo->start_pos + topinx;
    attr += topinx;
    draw_x = leftwidth;

    if(width != 0) {
        for(i=topinx; i<=tailinx; i++) {
	    c_width = FXTextWidth(p_font, text, 1);
	    leftwidth += c_width;
	    if(leftwidth > x + width) {
		tailinx = i;
		break;
	    }
	    text++;
	}
    }

    HttDrawXIMString(display, winfo->win_part, p_font, attr, draw_x,
		p_font->max_font_ascent, top, tailinx - topinx + 1, mode);

    if(tinfo->preedit_over &&
	   ( GET_HTT_VALUE(htt, preedit_over_mode) != PREEDIT_OVER_NON ) &&
	   winfo == cl->preedit_window_info
    )
	DisplayScrollGlyph(winfo);
}

static void
xsf_DestroyPreeditWindow()
{
    Display     *display = GET_HTT_VALUE(htt, display);

    Htt_PreeditWinRec	*winfo;

#ifdef	DEBUG
    dbg_printf( "*** xsf_Destroy Preedit start\n" );
#endif	/* DEBUG */
    winfo = CURRENT_CLIENT(htt)->preedit_window_info;
    for ( ; winfo != NULL; winfo = winfo->next_link ) {
	if ( ( winfo->status & PREEDITWIN_CREATE )
	  && ( !(winfo->status & PREEDITWIN_LINKED ) ) )
	    XDestroyWindow( display, winfo->win_part );
    }
    return;
}

static void
xsf_MakePreeditInfoPos( current_client, current_preedit, current_preedit_font )
    FXimp_Client	*current_client;
    FXimpFont		*current_preedit_font;
    Ximp_PreeditPropRec *current_preedit;
{
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    Display	   *display = GET_HTT_VALUE(htt, display);

    Htt_PreeditWinRec	*new_linked, *save_winfo;
    Htt_PreeditWinRec	*old_linked
				= current_client->linked_preedit_window_info;

#ifdef DEBUG
    dbg_printf( "*** xsf_MakePreeditInfoPos ***\n" );
    dbg_printf( "  old_linked=%8.8x preedit_over_mode=%d\n", old_linked, 
		GET_HTT_VALUE(htt, preedit_over_mode) );
#endif					/* DEBUG */

    if ( old_linked ) {
	old_linked->back_link->next_link = 0;
	DestroyPreeditInfo( current_client->linked_preedit_window_info );
    }
    save_winfo = current_client->preedit_window_info;
    MakePreeditInfo( display, current_client,
			current_preedit, current_preedit_font,
			&save_winfo, 0 , GET_HTT_VALUE(htt, max_preedit_line));
    if ( GET_HTT_VALUE(htt, preedit_over_mode) == PREEDIT_OVER_EXTENT ) {
	if ( current_client->ims_window_type & FC_USE_IMS_PREEDIT_WINDOW ) {
	    current_client->preedit_window_info = NULL;
	    CopyPreeditInfo(display, current_client, root_client );
	    new_linked = current_client->preedit_window_info;
	} else {
	    Ximp_PreeditPropRec	work_preedit;
	    work_preedit.Area.x = current_client->ims_preedit->x;
	    work_preedit.Area.y = current_client->ims_preedit->y;
	    work_preedit.Area.width  = current_client->ims_preedit->width;
	    work_preedit.Area.height = current_client->ims_preedit->height;
	    new_linked = current_client->linked_preedit_window_info;
	    MakePreeditInfo(display,  current_client,
				&work_preedit, current_preedit_font,
				&new_linked, PREEDITWIN_ROOT ,
				GET_HTT_VALUE(htt, max_preedit_line));
	}
	(void)LinkPreeditInfo( save_winfo, new_linked );
	current_client->linked_preedit_window_info = new_linked;
    }
    current_client->preedit_window_info = save_winfo;
    return;
}

static void
xsf_resize_ims_window( current_client, new_area )
    FXimp_Client	*current_client;
    Ximp_AreaRec	*new_area;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    int		ims_preedit_line = GET_HTT_VALUE(htt, ims_preedit_line);

    int			 work_gravity;
    int			 preedit_max_font_width, status_max_font_width;
    int			 half_font_width;
    Ximp_PreeditPropRec	*current_preedit = current_client->preedit;
    Ximp_StatusPropRec	*current_status  = current_client->status;
    FXimpFont		*current_preedit_font = current_client->preedit_font;
    FXimpFont		*current_status_font  = current_client->status_font;
    Ximp_AreaRec	 pre_work, *pre_area = &pre_work;
    Ximp_AreaRec	 sts_work, *sts_area = &sts_work;

#ifdef DEBUG
    dbg_printf("-Resize-IMS-Window new_width=%d\n", new_area->width);
#endif					/* DEBUG */
    *current_client->ims_area = *new_area;
    Get_IMSArea( current_client,
		current_client->ims_area, pre_area, sts_area, &work_gravity );
    if ( current_client->style & XIMPreeditNothing ) {
	if ( !(current_client->ims_window_type & FC_USE_IMS_PREEDIT_WINDOW) ) {
	    current_preedit->Area.width = pre_area->width;
	    MakePreeditInfo(display,  current_client, current_preedit,
		    current_preedit_font, &current_client->preedit_window_info,
		    PREEDITWIN_ROOT ,GET_HTT_VALUE(htt, max_preedit_line));
	    xsf_make_preedit_window( current_client, "XIMPreeditNothing",
			       current_preedit,
			       current_preedit_font, PREEDITWIN_ROOT );
	} else {
	    CopyPreeditInfo(display, current_client, root_client );
	}
    } else if ( current_client->style & XIMPreeditPosition ) {
	xsf_MakePreeditInfoPos( current_client, current_preedit,
			       current_preedit_font );
    }

    if (  ( !(current_client->ims_window_type & FC_USE_IMS_STATUS_WINDOW) )
       && ( current_client->style & XIMStatusNothing ) ) {
	current_status->Area.x = sts_area->x;
	XMoveResizeWindow( display, current_client->status_window,
			current_status->Area.x, current_status->Area.y,
		current_status->Area.width, current_status->Area.height );
    }

    current_client->ims_area->width  = new_area->width;
    return;
}

extern void
CreateRootWindow( current_client, pre_area, sts_area )
    FXimp_Client	*current_client;
    Ximp_AreaRec	*pre_area;
    Ximp_AreaRec	*sts_area;
{
    xsf_create_status_window( current_client, sts_area,
			current_client->status, current_client->status_font );
    xsf_create_preedit_window( current_client,
			current_client->preedit, current_client->preedit_font );
    return;
}

extern void
ChangeRootWindow( x, y, width, height )
    int			x;
    int			y;
    int			width;
    int			height;
{
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    Ximp_AreaRec	new_area;

#ifdef DEBUG
    dbg_printf("*** Change Root Window: x=%d, y=%d, width=%d, height=%d\n",
			x, y, width, height);
    dbg_printf("  OLD Root Window: x=%d, y=%d, width=%d, height=%d\n",
		root_client->ims_area->x, root_client->ims_area->y,
		root_client->ims_area->width, root_client->ims_area->height);
#endif					/* DEBUG */

    if (width == root_client->ims_area->width && 
              height == root_client->ims_area->height ) {
	root_client->ims_area->x = x;
	root_client->ims_area->y = y;
	return;
    }

    new_area.x = x;
    new_area.y = y;
    new_area.width  = width;
    new_area.height = height;

    xsf_resize_ims_window( root_client, &new_area );

    return;
}

static void
xsf_change_ims_window( emode )
    Bool		emode;
{
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);

#ifdef DEBUG
    dbg_printf("Change IMS Window By Client: x=%d, y=%d, width=%d, height=%d\n",
		root_client->ims_area->x, root_client->ims_area->y,
		root_client->ims_area->width, root_client->ims_area->height);
    dbg_printf("  OLD IMS Window: x=%d, y=%d, width=%d, height=%d\n",
		CURRENT_CLIENT(htt)->ims_area->x, CURRENT_CLIENT(htt)->ims_area->y,
		CURRENT_CLIENT(htt)->ims_area->width,
		CURRENT_CLIENT(htt)->ims_area->height);
#endif					/* DEBUG */

    if ( !emode
       && root_client->ims_area->width == CURRENT_CLIENT(htt)->ims_area->width )
	return;

    xsf_resize_ims_window( CURRENT_CLIENT(htt), root_client->ims_area );

/*
    if ( CURRENT_CLIENT(htt)->select_kanji_mod )
	CURRENT_CLIENT(htt)->lookup_data->max_position.width
				= CURRENT_CLIENT(htt)->ims_area->width;
*/
    return ;
}

extern void
Get_IMSArea( current_client, ims_area, pre_area, sts_area, gravity )
    FXimp_Client	*current_client;
    Ximp_AreaRec	*ims_area;
    Ximp_AreaRec	*pre_area;
    Ximp_AreaRec	*sts_area;
    int			*gravity;
{
    char	*geometry	   = GET_HTT_VALUE(htt, rootgeometry);
    int		ims_preedit_line   = GET_HTT_VALUE(htt, ims_preedit_line);
    int		ims_line 	   = GET_HTT_VALUE(htt, ims_line);
    /*** bugid 1115388
    int		ims_preedit_column = GET_HTT_VALUE(htt, ims_preedit_column);
    ***/
    int		bd_width 	   = GET_HTT_VALUE(htt, bd_width);
    Display     *display 	   = GET_HTT_VALUE(htt, display);
    int		screen 		   = GET_HTT_VALUE(htt, screen);
    int		sts_pos;

    XSizeHints		 hints;
    int			 geometry_mask;
    int			 font_half_width, font_half_height;
    int			 preedit_max_font_width, preedit_max_font_height;
    int			 status_max_font_width, status_max_font_height;
    int			 default_preedit_width;
    int			 default_ims_width;
    Ximp_PreeditPropRec	*current_preedit = current_client->preedit;
    Ximp_StatusPropRec	*current_status = current_client->status;
    FXimpFont		*current_preedit_font = current_client->preedit_font;
    FXimpFont		*current_status_font = current_client->status_font;

#ifdef DEBUG
   dbg_printf( "*** Get_IMSArea ***\n" );
   dbg_printf( "  ims_preedit_line=%d ims_line=%d ims_area(width)=%d\n", ims_preedit_line, ims_line, ims_area->width );
#endif					/* DEBUG */

    preedit_max_font_width = current_preedit_font->max_font_width;
    status_max_font_width  = current_status_font->max_font_width;
    preedit_max_font_height = current_preedit_font->max_font_height;
    status_max_font_height  = current_status_font->max_font_height;

    font_half_width  = MAX( (preedit_max_font_width / 2), 4 );
    font_half_height = MAX( (preedit_max_font_height / 2), 8 );

    default_preedit_width = preedit_max_font_width * 20; /* bugid 1115388 ims_preedit_column; */
    pre_area->height = preedit_max_font_height * ims_preedit_line
		     + (current_preedit->LineSpacing - preedit_max_font_height)
		     * ( ims_preedit_line - 1 );
    if (!(current_client->style & XIMStatusNothing))
        sts_area->width = 0;
    else
	sts_area->width = GET_HTT_VALUE(htt, status_root_maxwidth) 
			* (status_max_font_height / 2);
    /****
     *sts_area->width = status_max_font_width
     *			* GetMaxStatusMessageLength( current_client ); ****/
    sts_area->height = status_max_font_height;

    if ( ims_preedit_line >= ims_line ) {
	/*
	 *  |<--------------------ims_area->width------------------>|
	 *                                          |<--- ?? * w -->|
	 *  +-------------------------------------------------------+
	 *  |+-------------------------------------++--------------+|
	 *  ||  Preedit Window                     ||  Status Win. ||
	 *  |+-------------------------------------++--------------+|
	 *  +-------------------------------------------------------+
	 */
	if ( ims_area->width == 0 ) {
	    pre_area->width = default_preedit_width + 2;
	    ims_area->width = pre_area->width
				+ sts_area->width + font_half_width * 3;
	} else {
	    pre_area->width = ims_area->width
				- ( sts_area->width + font_half_width * 3 ) + 2;
	}
	ims_area->height = MAX( pre_area->height, sts_area->height )
				+ font_half_height * 2;
	sts_pos = GET_HTT_VALUE(htt, status_pos);
	if (CURRENT_CLIENT(htt)->style & XIMPreeditNothing &&
	    (sts_pos == STATUS_LEFT)) {
	    pre_area->x = sts_area->width + font_half_width * 2 ;
	    pre_area->y = font_half_width;
	    sts_area->x  = font_half_width;
	    sts_area->y  = font_half_width;
	}
	else {
	    pre_area->x = font_half_width;
	    pre_area->y = font_half_height;
	    sts_area->x  = pre_area->width + font_half_width * 2;
	    sts_area->y  = font_half_width;
	}	    
    } else {
	/*
	 *  |<--------------------ims_area->width------------------>|
	 *                                          |<--- ?? * w -->|
	 *  +-------------------------------------------------------+
	 *  |                                       +--------------+|
	 *  |                                       |  Status Win. ||
	 *  |                                       +--------------+|
	 *  |+-----------------------------------------------------+|
	 *  ||  Preedit Window                                     ||
	 *  |+-----------------------------------------------------+|
	 *  +-------------------------------------------------------+
	 */
	if ( ims_area->width == 0 ) {
	    pre_area->width = default_preedit_width + 2;
	    ims_area->width = MAX( pre_area->width, sts_area->width )
					+ font_half_width * 2;
	} else {
	    pre_area->width = ims_area->width - font_half_width * 2 + 2;
	}
	ims_area->height = pre_area->height + sts_area->height
				+ font_half_height * 3;
	pre_area->x = font_half_width;
        if (sts_area->width == 0)
	    pre_area->y = font_half_height;
	else
	    pre_area->y = sts_area->height + font_half_height * 2;
	if (CURRENT_CLIENT(htt)->style & XIMPreeditNothing && 
		(sts_pos == STATUS_LEFT)) 
	    sts_area->x = ims_area->width - (sts_area->width + font_half_width);
	else
	    sts_area->x = font_half_height;
	sts_area->y = font_half_height;
    }

    ims_area->x = DisplayWidth( display, screen )
			- ( ims_area->width + bd_width * 2 );
    if ( ims_area->x < 0 )
	ims_area->x = 0;
    ims_area->y = DisplayHeight(display, screen)
			- ( ims_area->height + bd_width * 2 );
    *gravity = SouthWestGravity;

    if (geometry) {
	geometry_mask = XParseGeometry(geometry, &hints.x, &hints.y,
	 (unsigned int *) &(hints.width), (unsigned int *) &(hints.height));
	if (geometry_mask & WidthValue)
	    ims_area->width = hints.width;
	if (geometry_mask & HeightValue)
	    ims_area->height = hints.height;

	ims_area->x = DisplayWidth( display, screen )
			- ( ims_area->width + bd_width * 2 );
	if ( ims_area->x < 0 )
	    ims_area->x = 0;
	ims_area->y = DisplayHeight(display, screen)
			- ( ims_area->height + bd_width * 2 );

	if ((geometry_mask & XValue) && (geometry_mask & XNegative))
	    hints.x += DisplayWidth(display, screen) - ims_area->width;
	if ((geometry_mask & YValue) && (geometry_mask & YNegative))
	    hints.y += DisplayHeight(display, screen) - ims_area->height;

	if (geometry_mask & XValue)
	    ims_area->x = hints.x;
	if (geometry_mask & YValue)
	    ims_area->y = hints.y;
	switch (geometry_mask & (XNegative | YNegative)) {
	case 0:
	    *gravity = NorthWestGravity;
	    break;
	case XNegative:
	    *gravity = NorthEastGravity;
	    break;
	case YNegative:
	    *gravity = SouthWestGravity;
	    break;
	default:
	    *gravity = SouthEastGravity;
	    break;
	}
    }
#ifdef DEBUG
    dbg_printf( "  Area(x,y)=(%d,%d), Area(width)=%d, Area(height)=%d\n", ims_area->x, ims_area->y, ims_area->width, ims_area->height );
#endif					/* DEBUG */
    return;
}

extern void
CreateWindows( current_client )
    FXimp_Client	*current_client;
{
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);

    int			 gravity;
    Ximp_StatusPropRec	*current_status  = current_client->status;
    Ximp_PreeditPropRec	*current_preedit  = current_client->preedit;
    FXimpFont		*current_status_font = current_client->status_font;
    FXimpFont		*current_preedit_font = current_client->preedit_font;
    Ximp_AreaRec	 sts_rec,
			 pre_rec;
    Ximp_AreaRec	*sts_area = &sts_rec,
			*pre_area = &pre_rec;

#ifdef DEBUG
    dbg_printf( "*** CreateWindows ***\n" );
#endif					/* DEBUG */
    *current_client->ims_area = *root_client->ims_area;
    Get_IMSArea( current_client, current_client->ims_area,
			pre_area, sts_area, &gravity );

    if (sts_area->width == 0)
    {
	current_client->preedit->Area.x = pre_area->x;
	current_client->preedit->Area.y = pre_area->y;
	current_client->preedit->Area.width = pre_area->width;
    }
    xsf_check_geometry( current_client, current_client->preedit,
			current_client->status );

    xsf_create_status_window( current_client, sts_area,
			      current_status, current_status_font );

    xsf_create_preedit_window( current_client,
			       current_preedit, current_preedit_font );

    return;
}

static void
xsf_create_status_window( current_client, sts_area,
			  current_status, current_status_font )
    FXimp_Client	*current_client;
    Ximp_AreaRec	*sts_area;
    Ximp_StatusPropRec	*current_status;
    FXimpFont		*current_status_font;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);

    int			 default_border_width2 = 0;
    Window		 parent;

    if ( current_client->style & ( XIMStatusCallbacks | XIMStatusNone ) )
	return;
#ifdef DEBUG
    dbg_printf( "*** xsf_create_status_window ***\n" );
    dbg_printf( "  style=%8.8x type=%8.8x\n", current_client->style, current_client->ims_window_type );
#endif					/* DEBUG */
    if ( current_client->style & XIMStatusArea ) {
	char    *w_name = "XIMStatusArea";
	if (current_client->ext_ui_statuswindow && current_status->window) {
	    parent = current_status->window;
	} else {
	    parent = current_client->window;
	}
	current_client->status_window =
		XCreateSimpleWindow( display, parent,
		    current_status->Area.x, current_status->Area.y,
		    current_status->Area.width, current_status->Area.height,
		    0, current_status->Foreground, current_status->Background);
	XmbSetWMProperties(display, current_client->status_window,
		&w_name[0], NULL, 0, NULL, NULL, NULL, NULL);
	ChangeStatusWindowAttributes( display,
			current_client->status_window, current_status );
#ifdef DEBUG
	dbg_printf("  CreateStatusWindow : status_window=%x parent\n",
			current_client->status_window, parent);
#endif					/* DEBUG */
    } else if ( current_client->style & XIMStatusNothing ) {
	if ( current_client->ims_window_type & FC_USE_IMS_STATUS_WINDOW ) {
	    *current_status_font = *root_client->status_font;
	    current_status_font->status = 0;
	    current_client->status_fontname = root_client->status_fontname;
	    current_client->status_window = root_client->status_window;
	    current_client->window_type |= FC_SAME_ROOT_STATUS_WINDOW;
	    return;
	} else {
	    char        *w_name = "XIMStatusNothing";
	    current_client->status_window = XCreateSimpleWindow( display,
		    root_client->window, sts_area->x, sts_area->y,
		    sts_area->width, sts_area->height, default_border_width2,
		    current_status->Foreground, current_status->Background );
	    XUnmapWindow(display, current_client->status_window);
	    current_client->status_visible = 0;
	    XmbSetWMProperties(display, current_client->status_window,
		&w_name[0], NULL, 0, NULL, NULL, NULL, NULL);
	    ChangeStatusWindowAttributes( display,
			current_client->status_window, current_status );
	}
    }

    if ( !( current_client->window_type & FC_SAME_ROOT_STATUS_GC ) )
	FXCreateGC( display, current_client->status_window,
		    current_status_font,
		    current_status->Foreground, current_status->Background );

    XSelectInput(display, current_client->status_window, ExposureMask);
    return;
}

static void
xsf_create_preedit_window( current_client,
				current_preedit, current_preedit_font )
    FXimp_Client	*current_client;
    Ximp_PreeditPropRec	*current_preedit;
    FXimpFont		*current_preedit_font;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    int			 mode = 0;
    int			 default_border_width2 = 0;

    if ( current_client->style & ( XIMPreeditCallbacks | XIMPreeditNone ) )
	return;
#ifdef DEBUG
    dbg_printf( "*** xsf_create_preedit_window ***\n" );
    dbg_printf( "  style=%8.8x ims_window_type=%8.8x\n", current_client->style, current_client->ims_window_type );
#endif					/* DEBUG */
    if ( current_client->style & XIMPreeditNothing ) {
	if ( current_client->ims_window_type & FC_USE_IMS_PREEDIT_WINDOW ) {
	    *current_preedit_font = *root_client->preedit_font;
	    current_preedit_font->status = 0;
	    current_client->preedit_fontname = root_client->preedit_fontname;
	    current_client->preedit_window = root_client->preedit_window;
	    CopyPreeditInfo(display, current_client, root_client );
	    current_client->window_type |= FC_SAME_ROOT_PREEDIT_WINDOW;

            if ((current_preedit->Area.x != root_client->preedit->Area.x ||
		current_preedit->Area.y != root_client->preedit->Area.y ||
		current_preedit->Area.width !=
			root_client->preedit->Area.width ||
		current_preedit->Area.height !=
			root_client->preedit->Area.height) &&
		!(current_client->style & XIMStatusNothing))
	    {
		Htt_PreeditWinRec       *winfo;
		int                     ydiff = 0;

		winfo = current_client->preedit_window_info;
		if (winfo)
		    ydiff = current_preedit->Area.y - winfo->area_part.y;
		for( ; winfo ; winfo = winfo->next_link )
		{
		    winfo->area_part.x = current_preedit->Area.x;
		    winfo->area_part.y += ydiff;
		    winfo->area_part.width = current_preedit->Area.width;
		    XMoveResizeWindow(display, winfo->win_part,
			winfo->area_part.x, winfo->area_part.y,
			winfo->area_part.width, winfo->area_part.height);
		}
	    }

	    return;
	} else {
	    MakePreeditInfo(display,  current_client, current_preedit,
			    current_preedit_font,
			    &current_client->preedit_window_info,
			    PREEDITWIN_ROOT, GET_HTT_VALUE(htt, max_preedit_line));
	    current_client->preedit_window =
		xsf_make_preedit_window( current_client, "XIMPreedit",
				current_preedit, current_preedit_font,
				PREEDITWIN_ROOT );
	}
    } else if ( current_client->style & XIMPreeditArea ) {
	MakePreeditInfo(display,  current_client, current_preedit,
			    current_preedit_font,
			    &current_client->preedit_window_info, 0 ,
			    GET_HTT_VALUE(htt, max_preedit_line));
	current_client->preedit_window =
		xsf_make_preedit_window( current_client, "XIMPreedit",
				current_preedit, current_preedit_font, 0 );
    } else if ( current_client->style & XIMPreeditPosition ) {
	current_client->input_flag = FINF_MODY;
	CreatePreeditPositionWindow( current_client, current_preedit_font );
    }

    if ( !( current_client->window_type & FC_SAME_ROOT_PREEDIT_GC ) )
	FXCreateGC( display, current_client->preedit_window,
		    current_preedit_font,
		    current_preedit->Foreground, current_preedit->Background );

    return;
}

static void
xsf_check_geometry( current_client, preedit, status )
    FXimp_Client	*current_client;
    Ximp_PreeditPropRec	*preedit;
    Ximp_StatusPropRec	*status;
{
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);

    Ximp_PreeditPropRec	*root_preedit = root_client->preedit;
    Ximp_StatusPropRec	*root_status  = root_client->status;
    FXimpFont		*root_preedit_font = root_client->preedit_font;
    FXimpFont		*preedit_font = current_client->preedit_font;
    FXimpFont		*root_status_font  = root_client->status_font;
    FXimpFont		*status_font  = current_client->status_font;

#ifdef DEBUG
    dbg_printf( "*** xsf_check_geometry ***\n" );
#endif				/* DEBUG */
    if ( ( preedit_font->max_font_height == root_preedit_font->max_font_height )
       && ( preedit->Foreground == root_preedit->Foreground )
       && ( preedit->Background == root_preedit->Background )
       && ( preedit->Bg_Pixmap == root_preedit->Bg_Pixmap )
       && ( preedit->LineSpacing == root_preedit->LineSpacing ) )
	current_client->ims_window_type |= FC_USE_IMS_PREEDIT_WINDOW;

    if ( ( status_font->max_font_height == root_status_font->max_font_height )
       && ( status->Foreground == root_status->Foreground )
       && ( status->Background == root_status->Background )
       && ( status->Bg_Pixmap == root_status->Bg_Pixmap )
       && ( status->LineSpacing == root_status->LineSpacing ) )
	current_client->ims_window_type |= FC_USE_IMS_STATUS_WINDOW;
#ifdef DEBUG
    dbg_printf( "  ims_window_type=%x\n", current_client->ims_window_type );
#endif					/* DEBUG */
    return;
}

extern void
ChangeWindows( current_client, preedit, status )
    FXimp_Client	*current_client;
    Ximp_PreeditPropRec	*preedit;
    Ximp_StatusPropRec	*status;
{
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);

    int			 gravity;
    Ximp_StatusPropRec	*current_status  = current_client->status;
    Ximp_PreeditPropRec	*current_preedit  = current_client->preedit;
    FXimpFont		*current_status_font = current_client->status_font;
    FXimpFont		*current_preedit_font = current_client->preedit_font;
    Ximp_AreaRec	 sts_rec,
			 pre_rec;
    Ximp_AreaRec	*sts_area = &sts_rec,
			*pre_area = &pre_rec;

#ifdef DEBUG
    dbg_printf( "*** Change Windows ***\n" );
#endif					/* DEBUG */
    *current_client->ims_area = *root_client->ims_area;
    Get_IMSArea( current_client, current_client->ims_area,
			pre_area, sts_area, &gravity );
    xsf_check_geometry( current_client, preedit, status );

    xsf_change_status_window( current_client, sts_area,
			      status, current_status, current_status_font );

    xsf_change_preedit_window( current_client,
			       preedit, current_preedit, current_preedit_font );

    return;
}

static void
xsf_change_status_window( current_client, sts_area, status,
			  current_status, current_status_font )
    FXimp_Client	*current_client;
    Ximp_AreaRec	*sts_area;
    Ximp_StatusPropRec	*status;
    Ximp_StatusPropRec	*current_status;
    FXimpFont		*current_status_font;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);

    int			 default_border_width2 = 0;
    Window		 parent;
    if ( current_client->style & ( XIMStatusCallbacks | XIMStatusNone ) )
	return;
#ifdef DEBUG
    dbg_printf( "*** xsf_change_status_window ***\n" );
#endif					/* DEBUG */
    if ( current_client->style & XIMStatusArea ) {
	if (current_client->ext_ui_statuswindow
	  && (status->window || status->window != current_status->window)) {
	    current_status->window = status->window;
	    if (status->window) {
		parent = status->window;
		current_status->Area.x = status->Area.x;
		current_status->Area.y = status->Area.y;
	    } else {
		parent = current_client->window;
	    }
	    XReparentWindow(display, current_client->status_window,
		    parent, current_status->Area.x, current_status->Area.y);
	}
	if ((status->Area.x != current_status->Area.x)
	    || (status->Area.y != current_status->Area.y)
	    || (status->Area.width != current_status->Area.width)
	    || (status->Area.height != current_status->Area.height)) {
	    XMoveResizeWindow(display, current_client->status_window,
			      status->Area.x, status->Area.y,
			      status->Area.width, status->Area.height);
	}
	current_status->Area.x = status->Area.x;
	current_status->Area.y = status->Area.y;
	current_status->Area.width  = status->Area.width;
	current_status->Area.height = status->Area.height;
    }
    if ( current_client->status_window == root_client->status_window ) {
	char    *w_name = "XIMStatusNothing";
	if ( current_client->ims_window_type & FC_USE_IMS_STATUS_WINDOW )
	    return;
	current_client->status_window = XCreateSimpleWindow( display,
		    root_client->window, sts_area->x, sts_area->y,
		    sts_area->width, sts_area->height, default_border_width2,
		    current_status->Foreground, current_status->Background );
	XUnmapWindow(display, current_client->status_window);
	current_client->status_visible = 0;
	XmbSetWMProperties(display, current_client->status_window,
		&w_name[0], NULL, 0, NULL, NULL, NULL, NULL);
    }
    current_client->window_type &= ~FC_SAME_ROOT_STATUS_WINDOW;
    current_client->ims_window_type &= ~FC_USE_IMS_STATUS_WINDOW;
    if (  ( status->Foreground != current_status->Foreground )
       || ( status->Background != current_status->Background ) ) {
	current_status->Foreground = status->Foreground;
	current_status->Background = status->Background;
	XSetWindowBackground( display,
			current_client->status_window, status->Background );
	if ( current_client->window_type & FC_SAME_ROOT_STATUS_GC ) {
	    current_client->window_type &= ~FC_SAME_ROOT_STATUS_GC;
	    FXCreateGC( display, current_client->status_window,
			current_status_font, current_status->Foreground,
			current_status->Background );
	} else {
	    FXChangeGC( display, current_client->status_window,
			current_status_font, current_status->Foreground,
			current_status->Background );
	}
    }
    current_status->Colormap = status->Colormap;
    current_status->Bg_Pixmap = status->Bg_Pixmap;
    current_status->LineSpacing = status->LineSpacing;
    current_status->Cursor = status->Cursor;
    ChangeStatusWindowAttributes( display,
			    current_client->status_window, current_status );
    XClearArea(display, current_client->status_window, 0, 0, 0, 0, True);
    return;
}


static int
xsf_change_status_geometry(current_client)
    FXimp_Client        *current_client;
{
    Display	*display = GET_HTT_VALUE(htt, display);
    int		ims_preedit_line   = GET_HTT_VALUE(htt, ims_preedit_line);
    int		ims_line 	   = GET_HTT_VALUE(htt, ims_line);
    Ximp_AreaRec        *sts_area;
    Ximp_StatusPropRec  *status;
    Ximp_StatusPropRec  *current_status = current_client->status;
    FXimpFont           *current_status_font = current_client->status_font;
    int length;
    int xx, ww, xx2, xx2_old, ww2;
    int			 font_half_width, font_half_height;
    int			 preedit_max_font_width, preedit_max_font_height;
    int			 status_max_font_width, status_max_font_height;
    Ximp_PreeditPropRec	*current_preedit = current_client->preedit;
    FXimpFont		*current_preedit_font = current_client->preedit_font;
    wchar_t 		*status_message;
    Htt_PreeditWinRec	*winfo;
 
#ifdef DEBUG
    dbg_printf("+++ xsf_change_status_geometry() +++\n");
#endif
    length = GetImlStatus_wcs(current_client, &status_message);
    if (!status_message)
        return 0;

    winfo = current_client->preedit_window_info;
    preedit_max_font_width = current_preedit_font->max_font_width;
    font_half_width  = MAX( (preedit_max_font_width / 2), 4 );

    xx = current_status->Area.x;
    if (wslen(status_message) > 12) {
	length = 12;
    }

/*****************************************************************************
* Removed just make sure there is no dynamic shrinking/expansion of luc,
* status, and so on.
******************************************************************************
*    ww = FXTextWidth(current_status_font, status_message, length);
*#ifdef DEBUG
*    dbg_printf("length, ww = %d, %d\n", length, ww);
*#endif
*    xx2 = xx + ww + 2 * GET_HTT_VALUE(htt, bd_width) + font_half_width * 2;
* 
*    xx2_old = current_client->preedit->Area.x;
* 
*    current_client->preedit->Area.x = xx2;
*    current_client->preedit->Area.width += xx2_old - xx2;
*
*    if(current_client->style & XIMStatusNothing) {
*        current_client->status->Area.width = ww + 2 * GET_HTT_VALUE(htt, bd_width);
*        XResizeWindow(display, current_client->status_window,
*                  current_client->status->Area.width,
*                  current_client->status->Area.height);
*    }
* 
*    if(ims_preedit_line >= ims_line) {
*	for( ; winfo ; winfo = winfo->next_link ) {
*	   if(current_client->style & XIMStatusNothing &&
*	      winfo->area_part.y == current_client->status->Area.y) {
*		winfo->area_part.x = xx2;
*		winfo->area_part.width += xx2_old - xx2;
*    		XMoveResizeWindow(display, winfo->win_part,
*			winfo->area_part.x, winfo->area_part.y,
*			winfo->area_part.width, winfo->area_part.height);
*	   }
*	   else {
*		winfo->area_part.x = font_half_width;
*		winfo->area_part.width =
*			current_client->ims_area->width - font_half_width * 2;
*    		XMoveResizeWindow(display, winfo->win_part,
*			winfo->area_part.x, winfo->area_part.y,
*			winfo->area_part.width, winfo->area_part.height);
*	   }
*	}
*    }
*
******************************************************************************/
    return length;
}


static void
xsf_change_preedit_window( current_client, preedit,
			  current_preedit, current_preedit_font )
    FXimp_Client	*current_client;
    Ximp_PreeditPropRec	*preedit;
    Ximp_PreeditPropRec	*current_preedit;
    FXimpFont		*current_preedit_font;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);

    if ( current_client->style & ( XIMPreeditCallbacks | XIMPreeditNone ) )
	return;
#ifdef DEBUG
    dbg_printf( "*** xsf_change_preedit_window ***\n" );
#endif					/* DEBUG */
    if (current_client->style & XIMPreeditArea) {
	if ((preedit->Area.x != current_preedit->Area.x)
	    || (preedit->Area.y != current_preedit->Area.y)
	    || (preedit->Area.width != current_preedit->Area.width)
	    || (preedit->Area.height != current_preedit->Area.height)) {
	    current_preedit->Area = preedit->Area;
	    MakePreeditInfo(display,  current_client, current_preedit,
			 current_preedit_font,
			&current_client->preedit_window_info, 0 ,
			GET_HTT_VALUE(htt, max_preedit_line));
	    (void)xsf_make_preedit_window( current_client, "XIMPreedit",
				current_preedit, current_preedit_font, 0 );
	}
    } else if (current_client->style & XIMPreeditPosition) {
	CheckPreeditWidowSize(preedit);
	if ((preedit->Area.x != current_preedit->Area.x)
	    || (preedit->Area.y != current_preedit->Area.y)
	    || (preedit->Area.width != current_preedit->Area.width)
	    || (preedit->Area.height != current_preedit->Area.height)
	    || (preedit->SpotLocation.x != current_preedit->SpotLocation.x)
	    || (preedit->SpotLocation.y != current_preedit->SpotLocation.y)
	    || (preedit->LineSpacing != current_preedit->LineSpacing)) {
	    if (preedit->SpotLocation.x != 0 || preedit->SpotLocation.y != 0)
		current_preedit->SpotLocation = preedit->SpotLocation;
	    current_preedit->LineSpacing = preedit->LineSpacing;
	    current_preedit->Area = preedit->Area;
	    current_client->input_flag = FINF_MODY;
	    ResizePreeditArea(current_client);
	}
    }

    if ( current_client->preedit_window == root_client->preedit_window ) {
	if ( current_client->ims_window_type & FC_USE_IMS_PREEDIT_WINDOW )
	    return;
	current_preedit->Area = preedit->Area;
	DestroyPreeditInfo( current_client->preedit_window_info );
	current_client->preedit_window_info = 0;
	MakePreeditInfo(display,  current_client, current_preedit,
			 current_preedit_font,
			&current_client->preedit_window_info, 0 ,
			GET_HTT_VALUE(htt, max_preedit_line));
	current_client->preedit_window
		= xsf_make_preedit_window( current_client, "XIMPreedit",
				current_preedit, current_preedit_font, 0 );
    }
    current_client->window_type &= ~FC_SAME_ROOT_PREEDIT_WINDOW;
    current_client->ims_window_type &= ~FC_USE_IMS_PREEDIT_WINDOW;
    if ((preedit->Background != current_preedit->Background)
	|| (preedit->Foreground != current_preedit->Foreground)) {
	current_preedit->Background = preedit->Background;
	current_preedit->Foreground = preedit->Foreground;
	XSetWindowBackground(display, current_client->preedit_window,
			     preedit->Background);
	if ( current_client->window_type & FC_SAME_ROOT_PREEDIT_GC ) {
	    current_client->window_type &= ~FC_SAME_ROOT_PREEDIT_GC;
	    FXCreateGC( display, current_client->preedit_window,
			current_preedit_font, current_preedit->Foreground,
			current_preedit->Background );
	} else {
	    FXChangeGC( display, current_client->preedit_window,
			current_preedit_font, current_preedit->Foreground,
			current_preedit->Background );
	}
    }
    current_preedit->Colormap = preedit->Colormap;
    current_preedit->Bg_Pixmap = preedit->Bg_Pixmap;
    current_preedit->Cursor = preedit->Cursor;
    current_preedit->AreaNeeded = preedit->AreaNeeded;
    ChangePreeditWindowAttributes(display, current_client->preedit_window,
			   current_preedit);
    XClearArea(display, current_client->preedit_window, 0, 0, 0, 0, True);
    return;
}

extern void
GetPreeditColormap( preedit )
    Ximp_PreeditPropRec		*preedit;
{
    Display     *display = GET_HTT_VALUE(htt, display);

    XStandardColormap		*std_colormap;
    int				 rc;
    int				 count;

#ifdef DEBUG
    dbg_printf("GetPreeditColormap: Colormap=%8.8x Atom=%d\n",
		preedit->Colormap, preedit->StdColormap);
#endif					/* DEBUG */

    if ( preedit->Colormap )
	return;

    if ( preedit->StdColormap ) {
	rc = XGetRGBColormaps( display, CURRENT_CLIENT(htt)->focus_window,
			&std_colormap, &count, preedit->StdColormap );
	if ( ( rc ) &&
	     ( std_colormap ) )
	    preedit->Colormap = std_colormap->colormap;
    }
#ifdef DEBUG
    dbg_printf("GetPreeditColormap: new-Colormap=%8.8x\n", preedit->Colormap);
#endif					/* DEBUG */
    return;
}

extern void
GetStatusColormap( status )
    Ximp_StatusPropRec		*status;
{
    Display     *display = GET_HTT_VALUE(htt, display);

    XStandardColormap		*std_colormap;
    int				 rc;
    int				 count;

#ifdef DEBUG
    dbg_printf("GetStatusColormap: Colormap=%8.8x Atom=%d\n",
		status->Colormap, status->StdColormap);
#endif					/* DEBUG */

    if ( status->Colormap )
	return;

    if ( status->StdColormap ) {
	rc = XGetRGBColormaps( display, CURRENT_CLIENT(htt)->focus_window,
			&std_colormap, &count, status->StdColormap );
	if ( ( rc ) &&
	     ( std_colormap ) )
	    status->Colormap = std_colormap->colormap;
    }
#ifdef DEBUG
    dbg_printf("GetStatusColormap: new-Colormap=%8.8x\n", status->Colormap);
#endif					/* DEBUG */
    return;
}

extern void
ClientMayBeResized(ev, cl)
    XConfigureEvent     *ev;
    FXimp_Client	*cl;
{
    Ximp_PreeditPropRec *pr;

    pr = cl->preedit;
    if(!pr)
	return;

    pr->Area.width = ev->width;
    pr->Area.height = ev->height;
}

