/*
****************************************************************************

              Copyright 1991, by FUJITSU LIMITED
              Copyright 1991, by Sun Microsystems, Inc.	      

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of FUJITSU LIMITED and Sun
Microsystems, Inc. not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

FUJITSU LIMITED AND SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

Note: This file is derived from the following 1 files:
	Xt/TranslateI.h		Original author: Gabe Beged-Dov, HP
				Former Author:	Charles Haynes
						Digital Equipment Corporation
						Western Research Laboratory

****************************************************************************
*/

/*
 * $XConsortium: TranslateI.h,v 1.42 91/06/14 17:58:41 converse Exp $
 */

/* 
 * TranslateI.h - Header file private to translation management
 */

/*#define REFCNT_TRANSLATIONS*/
#define CACHE_TRANSLATIONS

#define TM_NO_MATCH (-2)

#define _XtRStateTablePair "_XtStateTablePair"

#ifndef StringToQuark
#define	StringToQuark(str)	XrmStringToQuark(str)
#endif

typedef unsigned char TMByteCard;
typedef unsigned short TMShortCard;
typedef unsigned long TMLongCard;
typedef short TMShortInt;

typedef Boolean (*MatchProc)();
    /* Event *parsed, TMEventPtr incoming */

/*
typedef struct _ModToKeysymTable {
    Modifiers mask;
    int count;
    int idx;
} ModToKeysymTable;
*/

typedef struct _LateBindings {
    unsigned int knot:1;
    unsigned int pair:1;
    KeySym keysym;
} LateBindings, *LateBindingsPtr;

typedef short ModifierMask;

typedef struct _ActionsRec *ActionPtr;
typedef struct _ActionsRec {
    int		 idx;		/* index into quarkTable to find proc */
    String	*params;	/* pointer to array of params */
    Cardinal	 num_params;	/* number of params */
    ActionPtr	 next;		/* next action to perform */
} ActionRec;

typedef struct _CompileAction {
    XrmQuark	signature;
    HttActionProc	proc;
} CompileAction, *CompiledActionTable;

typedef struct _ActionListRec {
    ActionList		next;
    CompiledActionTable	table;
    TMShortCard		count;
} ActionListRec;

#define XtTableReplace	0
#define XtTableAugment	1
#define XtTableOverride	2
#define XtTableUnmerge  3

typedef unsigned int _XtTranslateOp;

typedef struct _EventSeqRec	*EventSeqPtr;
typedef struct _TMEventRec	*TMEventPtr;

/* NOTE: elements of this structure must match those of
 * TMSimpleStateTreeRec and TMComplexStateTreeRec.
 */
typedef struct _TMParseStateTreeRec{
    unsigned int	isSimple:1;
    unsigned int	isAccelerator:1;
    unsigned int	mappingNotifyInterest:1;
    unsigned int	unused:12; /* to ensure correct alignment */
    TMShortCard		numBranchHeads;
    TMShortCard		numComplexBranchHeads;
    TMShortCard		resurved;   /* # of entries in quarkTbl */
    EventSeqPtr		eventSeq;
}TMParseStateTreeRec, *TMParseStateTree;    

typedef struct _TMStateRec *	StatePtr;
typedef struct _TMStateRec {
    unsigned int	isCycleStart:1;
    unsigned int	isCycleEnd:1;
    TMShortCard		typeIndex;
    TMShortCard		modIndex;
    ActionPtr		actions;
    StatePtr		nextlevel;
} TMStateRec;

typedef struct _TranslationData{
    _XtTranslateOp	 operation; /*replace,augment,override*/
    TMParseStateTree	 parseTree; /* variable length */
}TranslationData;

#define _XtEventTimerEventType ((TMLongCard)~0L)
#define KeysymModMask		(1L<<27) /* private to TM */
#define AnyButtonMask		(1L<<28) /* private to TM */

typedef struct _EventRec {
    TMLongCard modifiers;
    TMLongCard modifierMask;
    LateBindingsPtr lateModifiers;
    TMLongCard eventType;
    TMLongCard eventCode;
    TMLongCard eventCodeMask;
    MatchProc matchEvent;
    Boolean standard;
} Event;

typedef struct _EventSeqRec {
    Event	event;	/* X event description */
    StatePtr	state;	/* private to state table builder */
    EventSeqPtr next;	/* next event on line */
    ActionPtr	actions;	/* r.h.s.   list of actions to perform */
    EventSeqPtr	next_level;
} EventSeqRec;

typedef EventSeqRec EventRec;
typedef EventSeqPtr EventPtr;

typedef struct _TMEventRec {
    XEvent 		*xev;
    Event		 event;
} TMEventRec;

typedef struct _TMEventSeq {
    struct _TMEventSeq		*next;
    TMEventRec			 tmEvent;
} TMEventSeq;

/* choose a number between 2 and 8 */
#define TMKEYCACHELOG2 6
#define TMKEYCACHESIZE (1<<TMKEYCACHELOG2)

#define TM_MOD_SEGMENT_SIZE 	16
#define TM_TYPE_SEGMENT_SIZE 	16

#define TMGetTypeMatch(idx) \
  ((TMTypeMatch) \
   &((_XtGlobalTM.typeMatchSegmentTbl[((idx) >> 4)])[(idx) & 15]))
#define TMGetModifierMatch(idx) \
  ((TMModifierMatch) \
   &((_XtGlobalTM.modMatchSegmentTbl[(idx) >> 4])[(idx) & 15]))

/* Useful Access Macros */
#define TMNewMatchSemantics() (_XtGlobalTM.newMatchSemantics)
#define TMBranchMore(branch) (branch->more)
#define TMComplexBranchHead(tree, br) \
  (((TMComplexStateTree)tree)->complexBranchHeadTbl[TMBranchMore(br)])

#define TMGetComplexBindEntry(bindData, idx) \
  ((TMComplexBindProcs)&(((TMComplexBindData)bindData)->bindTbl[idx]))

#define TMGetSimpleBindEntry(bindData, idx) \
  ((TMSimpleBindProcs)&(((TMSimpleBindData)bindData)->bindTbl[idx]))


#define _InitializeKeysymTables(dpy, pd) \
    if (pd->keysyms == NULL) \
        _XtBuildKeysymTables(dpy, pd)
